//CID://+v030R~:                                                   //+v030R~
//******************************************************************************//~v003I~
//v030:051108 enable clear when make mode to back to anss mode     //+v030I~
//v025:051104 (BUG)at start no input accepted(after automake input avail)//~v025I~
//v024:051103 (BUG)restore also score when restore pending game    //~v024I~
//v023:051102 (BUG)open doc ignored after make interrupted by timeout//~v023I~
//v022:051102 redundancy chk:max depth parm missing(no depth chk done at xnpsub)//~v022I~
//v021:051102 redundancy chk:display also reduduncy depth count    //~v021I~
//v020:051102 (BUG)redundant chk display also answer               //~v020I~
//v012:051004 dosenot write answer when in solving                 //~v012I~
//v004:050922 (BUG) Mode=MODE_NOINPUT; -->Mode=MODE_NOINPUT;       //~v004I~
//v003:000312 clear err only when err exist                        //~v003I~
//v002:000312 enter ans mode after make automaticaly               //~v002I~
//******************************************************************************//~v003I~
//*** Board.cpp **                                                 //~v019R~
//******************************************************************************//~9C09R~
//                                                                 //~v003R~
#include    "StdAfx.h"                                             //~9C25I~
#include    "wnpcdef.h"                                            //~0109R~
#include    "wnpsdef.h"                                            //~0212I~
#include    "Board.h"                                              //~0109I~
#include    "resource.h"                                            //~9C31I~
#include    "xnpsub2.h"                                            //~0129I~
                                                                   //~0109R~
enum OBJ_STAT { ST_EMPTY,ST_QDATA,ST_ANS,ST_PAT,ST_ERR,ST_RCHK,ST_NEXT,GRID1,GRID2,//~0212R~
				GRID1_MAKE,GRID2_MAKE};                            //~0212I~
                                                                   //~0101I~
COLORREF  OBJ_COLOR[] = {COL_BG_EMPTY                              //~9C31R~
						,COL_BG_Q                                  //~9C31R~
						,COL_BG_A                                  //~9C31R~
						,COL_BG_P                                  //~0101I~
						,COL_BG_E                                  //~0101I~
						,COL_BG_RCHK                               //~0109I~
						,COL_BG_NEXT                               //~0205I~
						,COL_GRID_BOX                              //~v003R~
						,COL_GRID_NUM                              //~0212R~
						,COL_GRID_BOX_MAKE                         //~0212I~
						,COL_GRID_NUM_MAKE};                       //~0212I~

// O[o֐
void    BoardToScreen( int bx, int by, int* px, int* py );
void    ShowObject( CDC* pDC, int bx, int by, OBJ_STAT sts,int PFocus);//~0211R~
BOOL	ScreenToBoard( int wx, int wy, int* pbx, int* pby );    // <---//~9C09I~
UINT MakeThread(LPVOID Pboard);
UINT AnsThread(LPVOID Plist);                                          //~0109I~
/*                                                                 //~9C09I~
==============================================================================//~9C09I~
    \[XIuWFNg̊O錾                                 //~9C09I~
==============================================================================*///~9C09I~
extern  "C"                                                        //~0110R~
{                                                                  //~0110I~
	char *GblNpsubMsg;                                             //~0110I~
	int GblSubthreadsw;                                            //~0110I~
	int GblSubthreadStopReq;                                           //~0110R~
	int GblUerrexitsw;                                             //~0110I~
}                                                                  //~0110I~
/*                                                                 //~9C09I~
===============================================================================
     Board::Board 
===============================================================================
@\    p^[|C^ƃ{[h}bv
===============================================================================*/
Board::Board()
{
    pPat = NULL;
    for ( int x = 0; x < MAP_SIZE; x ++ )
        for ( int y = 0; y < MAP_SIZE; y ++ )
            BoardMap[ y ][ x ] = new Hole( x, y );                 //~0102R~
    NumCount=0;                                                    //~0101R~
    Mode=MODE_INIT;                                                //~0116R~
    KbFocus=0;                                                     //~0211R~
    sMsg="";                                                       //~0102R~
    sTempMsg="";                                                   //~0102R~
    sSuccessMsg="";                                                //~0211R~
    sProbLevel="";                                                 //~0211I~
    Flags=0;                                                       //~0109R~
    SameNum=0;                                                     //~0206R~
    CurNum=1;       //cursol number                                //~0212I~
    Shiftkey=0;                                                    //~0206I~
    ActSeed=0;                                                     //~0212I~
    MaxFixed=FixedSeq=0;                                           //~0109I~
    TryTimeSpan=0;                                    //~0212I~
    Score=0;                                                       //~0213I~
    ScoreMax=0;                                                    //~0226I~
}
CString Board::GetMsg()                                            //~0101I~
{                                                                  //~0101I~
    CString csnull="";                                             //~0102R~
    if (Flags&F_THREAD)                                            //~0130I~
    	sMsgOut="lAe~f{^Œf܂";              //~v003R~
    else                                                           //~0130I~
	if (sTempMsg!=csnull)                                          //~0102R~
    {                                                              //~0102I~
    	sMsgOut=sTempMsg;                                         //~0102I~
        sTempMsg=csnull;                                           //~0102R~
	}                                                              //~0102I~
    else                                                           //~0102I~
    	sMsgOut=sMsg;                                             //~0102I~
	return sMsgOut;                                                //~0102R~
}                                                                  //~0101I~
void Board::SetTempMsg(CString Pmsg)                               //~0102I~
{                                                                  //~0102I~
                                                                   //~0102I~
	sTempMsg=Pmsg;                                                 //~0102I~
}                                                                  //~0102I~
/*
===============================================================================
     Board::~Board 
===============================================================================
@\    A؃O폜
===============================================================================*/
Board::~Board()
{
    for ( int x = 0; x < MAP_SIZE; x ++ )
        for ( int y = 0; y < MAP_SIZE; y ++ )
            delete  BoardMap[ y ][ x ];
}
//===============================================================================//~0206R~
//return Mode at entry                                             //~0206R~
//===============================================================================*///~0206R~
void    Board::CreateBoard( CPattern* pat )                        //~0206R~
{
    int oldmode=Mode;                                              //~0206I~
    int pendsw=0;                                                  //~v012I~
//***************************************                          //~v012R~
    pPat = pat;
    ActSeed=pat->Seed;                                             //~v012R~
    NumCount=0;                                                    //~0101R~
    for ( int bx = 0; bx < MAP_SIZE; bx ++ )
        for ( int by = 0; by < MAP_SIZE; by ++ )
        {
            if ( BoardMap[ by ][ bx ] )
            {
                delete BoardMap[ by ][ bx ];
                BoardMap[ by ][ bx ] = NULL;
            }
            BoardMap[ by ][ bx ] = new Hole( bx, by );
            int num;                                               //~9C09I~
            if ( num=pPat->QuestionData[ by ][ bx ],num )          //~9C09R~
            {
                BoardMap[ by ][ bx ]->SetNum(num,MODE_FILEDATA,0); //~0116R~
                NumCount++;                                        //~0101R~
            }
            else                                                   //~0116I~
                BoardMap[ by ][ bx ]->SetNum(0,0,0);               //~0116I~
        }
    if (NumCount)                                                  //~0116I~
    {                                                              //~0116I~
        if (oldmode==MODE_INIT)                                    //~0206I~
            OnAnswer();                                            //~0206I~
//      else                                                       //~v023R~
//  		if (!(Flags & F_MODEMAKE))                             //~v023R~
//      		Flags|=F_MODEANS;                                  //~v023R~
	    Mode=MODE_KEYINDATA;          //next is keyin              //~0116R~
    	Flags&=~F_MODEMAKE;                                        //~v023I~
        Flags|=F_MODEANS;                                          //~v023I~
    }                                                              //~0116I~
//  else                                                           //~v023R~
//      if (!(Flags & F_MODEANS))                                  //~v003R~
//          Flags|=F_MODEMAKE;                                     //~v003R~
//  	if (!(Flags & F_MODEMAKE))                                 //~v023R~
//      	Flags|=F_MODEANS;                                      //~v023R~
    Flags&=~(F_ERROR|F_ONXX);                                      //~0130R~
//restore pending data                                             //~v012I~
    for ( int ii = 0; ii < MAP_SIZE; ii ++ )                       //~v012R~
        for ( int jj = 0; jj < MAP_SIZE; jj ++ )                   //~v012R~
        {                                                          //~v012I~
        	if (pPat->PendingData[ii][jj])                         //~v012R~
            {                                                      //~v012I~
            	pendsw=1;                                          //~v012R~
                break;                                             //~v012I~
            }                                                      //~v012I~
        }                                                          //~v012I~
    if (pendsw)                                                    //~v012R~
    {                                                              //~v012I~
   		Flags&=~F_ONXX;                                            //~v012I~
    	Flags|=F_ONTRY;                                            //~v012I~
    	Flags|=F_READFILE;                                         //~v012I~
        OnSetend(0);    //get anser data                           //~v012R~
        ScoreMax=pPat->ScoreMax;                                   //~v024R~
    }                                                              //~v012I~
    sProbLevel="";                                                 //~0211I~
}
//******************************************                       //~v012I~
//restore pending data                                             //~v012I~
//******************************************                       //~v012I~
void    Board::Restoreprevinput( )                                 //~v012I~
{                                                                  //~v012I~
	int inputnum;                                                  //~v012I~
    for ( int ii = 0; ii < MAP_SIZE; ii ++ )                       //~v012I~
        for ( int jj = 0; jj < MAP_SIZE; jj ++ )                   //~v012I~
        {                                                          //~v012I~
        	inputnum=pPat->PendingData[ii][jj];                    //~v012I~
            if (inputnum)                                          //~v012I~
            {                                                      //~v012I~
//              BoardMap[ii][jj]->SetNum(inputnum,MODE_KEYINANS,0);//~v024R~
                BoardMap[ii][jj]->SetNum(inputnum,MODE_KEYINANS,HOLE_PENDDATA);//~v024I~
                NumCount++;                                        //~v012I~
            }                                                      //~v012I~
        }                                                          //~v012I~
}                                                                  //~v012I~
////===============================================================================*///~0122R~
void    Board::ResetErr(int Pnextclearsw)                          //~0205R~
{                                                                  //~0122R~
	int err;                                                  //~0212I~
    for ( int bx = 0; bx < MAP_SIZE; bx ++ )                       //~0122R~
        for ( int by = 0; by < MAP_SIZE; by ++ )                   //~0122R~
        {                                                          //~0212I~
        	err=BoardMap[ by ][ bx ]->GetErr();                    //~0212R~
            if (!err)                                              //~0212I~
            	continue;                                          //~0212I~
            if (err==HOLE_PENDDATA) 	//keep file input pending data//~v024I~
            	continue;                                          //~v024I~
            err=(err/HOLE_NEXT)*HOLE_NEXT;	//clear other than NEXT//~0212I~
        	if (Pnextclearsw)                                      //~0212I~
            	if (err>=HOLE_NEXT)                                //~0212I~
                	err-=HOLE_NEXT;                                //~0212I~
    	    BoardMap[ by ][ bx ]->SetNum(-1,-1,err);               //~0212R~
		}	                                                       //~0212I~
}                                                                  //~0122R~
//===============================================================================*///~0102I~
//===============================================================================*///~0103I~
//=for Question case                                               //~0116I~
//===============================================================================*///~0116I~
void    Board::SetAllAnswer()                                      //~0116R~
{                                                                  //~0103I~
	PM99  pm99;                                                    //~0103I~
    PNPWORKT pnpwt;                                                //~0103I~
    int  mode,err,num;                                             //~0122R~
//*********                                                        //~0103I~
    pnpwt=&Npworkt;                                                //~0109R~
    for ( int bx = 0; bx < MAP_SIZE; bx ++ )                       //~0103I~
        for ( int by = 0; by < MAP_SIZE; by ++ )                   //~0103I~
        {                                                          //~0103I~
            Hole *phole=BoardMap[ bx ][ by ];                      //~0103R~
		    pm99=&pnpwt->m99[bx][by];     //answer                 //~0110R~
            num=phole->GetNum();          //init data              //~0130I~
            if (!num)					//may set ans	           //~0130I~
        		if (Flags&F_MODEANS)    //ignore ans when make mode//~0130R~
            		num=pm99->fnum;		//result                   //~0130R~
            err=0;                                                 //~0108I~
            if (num)                                               //~0122R~
                if (MaxFixed && MaxFixed!=PEG_MAX)  //err          //~0122R~
                {                                                  //~0122R~
                    if (MaxFixed==pm99->fseq && NpsubRc!=12)  //err stopped not multi sol//~0130R~
                        err=HOLE_ERR;                              //~0122R~
                    if (!pm99->fnum||pm99->dlvl==LEVEL_INIT)	//	init data err//~0122I~
                    	mode=phole->GetState();                           //~0122R~
                    else                                           //~0122I~
                    	mode=MODE_OUTANS;                          //~0123R~
                }                                                  //~0122R~
                else                                               //~0122R~
                    if (pm99->dlvl==LEVEL_INIT)                    //~0122I~
                        mode=-1;    //no change                    //~0122I~
                    else                                           //~0122I~
						if (Flags&F_ONRCHK) //set all when rchk mode//~0116I~
//                          mode=MODE_OUTANS;                      //~v020R~
                            mode=-1;	//nochange                 //~v020R~
                        else                                       //~0108R~
                            mode=-1;	//nochange                 //~0116R~
			else                                                   //~0103I~
            	mode=0;                                            //~0103I~
            if (mode>=0)	//set data                             //~0116I~
            {                                                      //~0123I~
            	phole->SetNum(num,mode,err);                       //~0122R~
            }                                                      //~0123I~
                                                                   //~0103I~
        }                                                          //~0103I~
	if ((Flags & F_ONRCHK) && MaxFixed==PEG_MAX)                      //~0129R~
    {                                                              //~0129I~
//      Mode=MODE_OUTANS;                                          //~v020R~
//  	FixedSeq=MaxFixed;                                         //~v020R~
//      SaveAnswer();                                              //~v020R~
        MaxFixed=FixedSeq=pnpwt->idatano;		//initial no       //~v020I~
	    pnpwt->seqno=MaxFixed;                                     //~v020I~
    }                                                              //~0129I~
    else                                                           //~0109I~
//        if (!(Flags & F_ONTRY))                                  //~0130R~
        {                                                          //~0130R~
            if (MaxFixed!=PEG_MAX)  //err                          //~0130R~
                FixedSeq=MaxFixed;                                 //~0130R~
            else                                                   //~0130R~
                FixedSeq=pnpwt->idatano;                           //~0130R~
            if (MaxFixed!=pnpwt->idatano)                          //~0130R~
                Mode=MODE_OUTANS;                                  //~0130R~
        }                                                          //~0130R~
                                                                   //~0129I~
}                                                                  //~0103I~
//===============================================================================*///~v012I~
//get current input number                                         //~v012I~
//===============================================================================*///~v012I~
void    Board::GetInpnum(int *Pinpnum)                             //~v012R~
{                                                                  //~v012I~
	Hole *phole;                                                   //~v012I~
    int  ii,jj,*pi;                                                //~v012R~
//*******************************                                  //~v012I~
    for (ii=0,pi=Pinpnum;ii<MAP_SIZE;ii++)                         //~v012R~
        for (jj=0;jj<MAP_SIZE;jj++,pi++)                           //~v012R~
        {                                                          //~v012I~
	    	phole=BoardMap[ii][jj];                                //~v012R~
            if (phole)                                             //~v012I~
	    		*pi=phole->GetNum();                               //~v012R~
            else                                                   //~v012I~
	    		*pi=0;                                             //~v012R~
        }                                                          //~v012I~
}                                                                  //~v012I~
//===============================================================================*///~0129I~
//save hole answer data to pattern for answer write                //~0129I~
//===============================================================================*///~0129I~
void    Board::SaveAnswer()                                        //~0129I~
{                                                                  //~0129I~
    for (int ii=0;ii<MAP_SIZE;ii++)                                //~0129I~
        for (int jj=0;jj<MAP_SIZE;jj++)                            //~0129I~
	    	pPat->SetAnsData(ii,jj,BoardMap[ii][jj]->GetNum());    //~0129I~
}                                                                  //~0129I~
//===============================================================================*///~0312I~
//save xnp result answer                                           //~0312I~
//===============================================================================*///~0312I~
void    Board::SaveAnswerXnp()                                     //~0312I~
{                                                                  //~0312I~
//*******************                                              //~0312I~
    for (int ii=0;ii<MAP_SIZE;ii++)                                //~0312I~
        for (int jj=0;jj<MAP_SIZE;jj++)                            //~0312I~
	    	pPat->SetAnsData(ii,jj,Npworkt.m99[ii][jj].fnum);     //answer//~0312R~
}                                                                  //~0312I~
//===============================================================================*///~0129I~
//=che i'll try answer                                             //~0129I~
//===============================================================================*///~0129I~
int Board::CheckAnswer(int Pallsw)                                 //~0312R~
{                                                                  //~0129I~
    int   ii,jj,err=0,num;                                         //~0312R~
    Hole *phole;                       //~0129I~
    CTime ctime;                                                   //~0212I~
//************                                                     //~0129I~
	ResetErr(0);	//once clear err                               //~0212I~
//row                                                              //~0129I~
    for (ii=0;ii<MAP_SIZE;ii++)                                    //~0312R~
        for (jj=0;jj<MAP_SIZE;jj++)
	    {//~0312R~
        	phole=BoardMap[ii][jj];
		    num=phole->GetNum();                                   //~0312R~
			if (num!=pPat->GetAnsData(ii,jj))                      //~0312I~
		    	if (Pallsw || num)                                 //~0312I~
                {                                                  //~0312I~
	                err=1;                                         //~0312I~
            		phole->SetNum(-1,-1,HOLE_ERR);                 //~0312R~
                }                                                  //~0312I~
	    }	//~0312I~
	if (Pallsw)                                                    //~0312I~
        if (!err)                                                  //~0312R~
        {                                                          //~0312R~
            CongMsg=0;                                             //~0312R~
            OnSuccess();                                           //~0312R~
            Mode=MODE_OUTANS;                                      //~0312R~
            CTime  ctime=CTime::GetCurrentTime();                  //~0312R~
            CTimeSpan  ts=ctime-TryStartTime;                      //~0312R~
            TryTimeSpan=ts.GetTotalSeconds();                      //~0312R~
            pView->KillTimer(IDC_SETEND);                          //~0312R~
            CalcScore();                                           //~0312R~
        }                                                          //~0312R~
        else                                                       //~0312R~
        {                                                          //~0312R~
            Flags|=F_ERROR;                                        //~0312R~
            SetTempMsg("H");                                  //~0312R~
        }                                                          //~0312R~
    return err;                                                    //~0312I~
}                                                                  //~0129I~
//=============================================================================*///~0211I~
int     Board::OnSuccess()                                         //~0212R~
{                                                                  //~0211I~
#define MAX_CONG 6                                                 //~0211I~
	int waittm[MAX_CONG]={1,1,1,2,1,3};                             //~0211I~
    int col;                                                       //~0211I~
    SetTempMsg("I");                                          //~0227I~
    if (CongMsg>=MAX_CONG)                                         //~0211R~
    {                                                              //~0211I~
    	pView->KillTimer(IDC_SUCCESS);                             //~0211I~
        return TryTimeSpan;                                        //~0212R~
	}                                                              //~0211I~
    col=OBJ_COLOR[ST_QDATA];                                       //~0211R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211R~
    OBJ_COLOR[ST_QDATA]=col;                                       //~0211R~
                                                                   //~0211R~
    col=OBJ_COLOR[ST_ANS];                                         //~0211R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211R~
    OBJ_COLOR[ST_ANS]=col;                                         //~0211R~
                                                                   //~0211R~
    col=OBJ_COLOR[ST_NEXT];                                        //~0211I~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211I~
    OBJ_COLOR[ST_NEXT]=col;                                        //~0211I~
                                                                   //~0211I~
    col=OBJ_COLOR[GRID1];                                          //~0211R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211R~
    OBJ_COLOR[GRID1]=col;                                          //~0211R~
                                                                   //~0211R~
    col=OBJ_COLOR[GRID2];                                          //~0211R~
    col=((col & 0x0000ffff)<<8)+((col & 0x00ff0000)>>16);          //~0211R~
    OBJ_COLOR[GRID2]=col;                                          //~0211R~
    if (CongMsg)                                                   //~0211I~
    	pView->KillTimer(IDC_SUCCESS);                             //~0211I~
    pView->SetTimer(IDC_SUCCESS,waittm[CongMsg]*500,NULL);   //50 ms frequency//~0211R~
    CongMsg++;                                                     //~0211R~
    return 0;                                                      //~0212I~
}                                                                  //~0211I~
//===============================================================================*///~0108I~
int Board::SetNextAnswer(int Pfixedseq)                            //~0108R~
{                                                                  //~0108I~
	PM99  pm99;                                                    //~0108I~
    PNPWORKT pnpwt;                                                //~0108I~
	Hole *phole;                                                   //~0108I~
    int  bx,by;                                                    //~0123R~
//*********                                                        //~0108I~
    pnpwt=&Npworkt;                                                //~0109R~
//reset previous last id                                           //~0108I~
    for (bx = 0; bx < MAP_SIZE; bx ++ )                       //~0108I~
        for (by = 0; by < MAP_SIZE; by ++ )                   //~0108I~
        {                                                          //~0108I~
		    pm99=&pnpwt->m99[bx][by];     //answer                 //~0108I~
            if (pm99->fnum)                                        //~0108I~
            {                                                      //~0108I~
            	if (pm99->fseq==Pfixedseq-1)                       //~0108I~
                {                                                  //~0108I~
		            phole=BoardMap[ bx ][ by ];                    //~0108I~
                    if (phole->GetState()==MODE_OUTANS)            //~0116R~
	            		phole->SetNum(pm99->fnum,MODE_OUTANS,0);//reset err//~0123I~
            	}                                                  //~0108I~
            }                                                      //~0108I~
        }                                                          //~0108I~
    for (bx = 0; bx < MAP_SIZE; bx ++ )                       //~0108I~
        for (by = 0; by < MAP_SIZE; by ++ )                   //~0108I~
        {                                                          //~0108I~
		    pm99=&pnpwt->m99[bx][by];     //answer                 //~0108I~
            if (pm99->fnum)                                        //~0108I~
            {                                                      //~0108I~
            	if (pm99->fseq==Pfixedseq)                         //~0108I~
                {                                                  //~0108I~
		            phole=BoardMap[ bx ][ by ];                    //~0108I~
            		phole->SetNum(pm99->fnum,MODE_OUTANS,0);       //~0116R~
                    KbFocus=bx*MAP_SIZE+by;    //set forcus        //~0211R~
                    NumCount++;                                    //~0123I~
                    return 0;                                      //~0108I~
            	}                                                  //~0108I~
            }                                                      //~0108I~
        }                                                          //~0108I~
	return 4;                                                      //~0108I~
}                                                                  //~0108I~
/*
===============================================================================
     Board::Show 
===============================================================================
@\    {[h\
    pDC  DC
===============================================================================*/
void    Board::Show(CDC* pDC,CFont *Pmemofont)                     //~0205R~
{
    int samenum=SameNum;                                           //~0212I~
    if (Flags & F_MODEMAKE)                                        //~0212I~
        samenum=0;                                                 //~0212I~
    ShowGrid(pDC);                                                 //~0101I~
                                                                   //~0205I~
    for ( int bx = 0; bx < MAP_SIZE; bx ++ )
        for ( int by = 0; by < MAP_SIZE; by ++ )
        {
            if ( BoardMap[ by ][ bx ] )
                BoardMap[ by ][ bx ]->Show( pDC,Pmemofont,         //~0205R~
                                            (KbFocus==by*MAP_SIZE+bx),//~0211R~
                                             samenum,              //~0212R~
							                 Flags&F_MODEANS||Mode==MODE_ENDQDATA);//~0123R~
        }
}
//=============================================================================*///~9C09I~
void    Board::ShowGrid( CDC* pDC)                                 //~9C09I~
{                                                                  //~9C09M~
    int x, y,bx;                          //~9C09M~
	CBrush  br1M( OBJ_COLOR[GRID1_MAKE] );             // `IuWFNg̐F//~0212I~
    CBrush  br2M( OBJ_COLOR[GRID2_MAKE] );             // `IuWFNg̐F//~0212I~
	CBrush  br1A( OBJ_COLOR[GRID1] );             // `IuWFNg̐F//~0212I~
    CBrush  br2A( OBJ_COLOR[GRID2] );             // `IuWFNg̐F//~0212I~
	CBrush *old_br;
    if (Flags & F_MODEMAKE)                                        //~0212M~
    	old_br = pDC->SelectObject( &br1M);   //inner grid;save cuurrent//~0212I~
    else                                                           //~0212I~
    	old_br = pDC->SelectObject( &br1A);   //inner grid;save cuurrent//~0212R~
                                                                   //~9C09M~
    ::BoardToScreen( 0,0, &x, &y );          // `ʒu߂   //~9C09I~
    pDC->Rectangle( x-GAP, y-GAP, x+(OBJECT_SIZE+GAP)*MAP_SIZE,y+(OBJECT_SIZE+GAP)*MAP_SIZE);//~9C09I~
                                                                   //~9C09I~
    if (Flags & F_MODEMAKE)                                        //~0212I~
    	pDC->SelectObject( &br2M);				//outer grid       //~0212R~
    else                                                           //~0212I~
    	pDC->SelectObject( &br2A);				//outer grid       //~0212I~
    for ( bx = 0; bx <MAP_SIZE; bx ++ )      //virtical line       //~9C09R~
    {                                                              //~9C09I~
    	::BoardToScreen( bx/3*3,bx%3*3, &x, &y );          // `ʒu߂//~9C09R~
	    pDC->Rectangle( x, y, x+(OBJECT_SIZE+GAP)*3-GAP,y+(OBJECT_SIZE+GAP)*3-GAP);//~9C09I~
	}                                                              //~9C09R~
                                                                   //~9C09I~
    pDC->SelectObject( old_br );                                   //~9C09M~
}                                                                  //~9C09M~
                                                                 //~9C09I~
//=============================================================================*///~0101I~
//condition to NumBtn dispable                                     //~0101I~
// return numbutton enable                                         //~0116I~
//=============================================================================*///~0101I~
BOOL  Board::ShowNumBtn()                                          //~0101R~
{                                                                  //~0101I~
	BOOL enable=FALSE;                                             //~0130R~
    if (Flags&F_THREAD)                                            //~0129I~
    	return enable;		//false                                //~0129I~
                                                                   //~0130I~
    switch (Mode)                                                 //~0101I~
    {                                                              //~0101I~
    case MODE_INIT:                                                //~0102I~
        enable=TRUE;                                               //~v003I~
    	sMsg.Format("ݒ肵ĂB͂t@Cj[efB");//~v003R~
        break;                                                     //~0102I~
    case MODE_NOINPUT:                                             //~0122R~
        if (Flags&F_MODEANS)                                       //~0122R~
        {                                                          //~0122R~
            enable=TRUE;                                           //~0122R~
            sMsg.Format("f[^ݒ肵Ă");           //~0122R~
        }                                                          //~0122R~
        else                                                       //~0122R~
            sMsg.Format("p^[[f[^ݒ肵Ă");     //~0122R~
        break;                                                     //~0122R~
    case MODE_FILEDATA:		//just after file in                   //~0116R~
		if (Flags&F_MODEANS)                                       //~0116R~
	    	enable=TRUE;                                           //~0116I~
    	sMsg.Format("CȂ΁eIfĂJnĂ");//~v003R~
        break;                                                     //~0101I~
    case MODE_KEYINDATA:	//input from screen                    //~0116I~
        if (Flags&F_MODEANS)                                       //~0129R~
            enable=TRUE;                                           //~0129R~
        sMsg.Format("ݒ芮ȂeIfĂJnĂ");//~v003R~
        break;                                                     //~0116I~
    case MODE_ENDQDATA:                                             //~0116R~
//        if (Flags&F_MODEANS)                                     //~v003R~
//        {                                                        //~v003R~
	    	sMsg.Format("͂IeHfă`FbNĂ");//~v003R~
    		enable=TRUE;                                           //~0123I~
//        }                                                        //~v003R~
//        else                                                     //~v003R~
//            sMsg.Format("쐬,ꍇ͉𓚃[hɂĂ");//~v003R~
        break;                                                     //~0116M~
    case MODE_KEYINANS:                                            //~0116I~
//        if (Flags & F_ANSCHK)                                    //~0205R~
//        {                                                        //~0205R~
//            if (NpsubRc)                                         //~0205R~
//            {                                                    //~0205R~
//                SetTempMsg("H");                            //~0205R~
//                enable=TRUE;                                     //~0205R~
//            }                                                    //~0205R~
//            else                                                 //~0205R~
//            {                                                    //~0205R~
//                SetTempMsg("I");                            //~0205R~
//                sMsg.Format("I");                           //~0205R~
//            }                                                    //~0205R~
//        }                                                        //~0205R~
//        else                                                     //~0205R~
//        {                                                        //~0205R~
//            sMsg.Format("͂esfŊmFĂ");//~0227R~
//            enable=TRUE;                                         //~0205R~
//        }                                                        //~0205R~
        if (NumCount==PEG_MAX)                                     //~0205I~
        {                                                          //~0212I~
        	if (Flags & F_ERROR)                                   //~0212I~
    			enable=TRUE;                                       //~0212I~
            else                                                   //~v012I~
        	sMsg.Format("eHfŊmFĂ");           //~v003R~
        }                                                          //~0212I~
        else                                                       //~0205I~
        {                                                          //~0205I~
        	sMsg.Format("󔒂𖄂߂Ă");                   //~0205R~
            enable=TRUE;                                           //~0205I~
        }                                                          //~0205I~
        break;                                                     //~0116I~
    case MODE_OUTANS:                                              //~0116I~
        if (Flags & F_ERROR)                                       //~0130I~
    		enable=TRUE;                                           //~0130I~
	    sMsg.Format(sSuccessMsg);                                 //~0129R~
        break;                                                     //~0116I~
    }                                                              //~0101I~
//    if (!enable)                                                 //~0205R~
//        CurNum=0;                                                //~0205R~
    return enable;                                                 //~0101I~
}                                                                  //~0101I~
//===============================================================================//~0123R~
BOOL	Board::DropDown( CPoint point,int Pnum)                    //~0102R~
{                                                                  //~9C09I~
    int    bx, by,newnum;                                          //~0102R~
    int    oldmode=Mode;                                           //~0123I~
    if (Pnum==-1)         //mouse                                  //~0129R~
    {                                                              //~0102I~
    	if ( ! ::ScreenToBoard( point.x, point.y, &bx, &by ) )     //~0102R~
        	return FALSE;                      // {[h̏ł͂Ȃ//~0102R~
	    KbFocus=by*MAP_SIZE+bx;                                    //~0211R~
	}                                                              //~0102I~
	else                  //kbd input                              //~0129R~
    {                                                              //~0102I~
    	bx=KbFocus%MAP_SIZE;                                       //~0211R~
    	by=KbFocus/MAP_SIZE;                                       //~0211R~
    }                                                              //~0102I~
    Hole*   p_hole= BoardMap[ by ][ bx ];                          //~0101M~
    if (Pnum==-1)                                                  //~v025I~
    	newnum=CurNum;		//from mouse                           //~v025I~
	else                                                           //~v025I~
    	newnum=Pnum;                                               //~v025I~
//  if ( ! CanMove(p_hole) )                                       //~v025R~
    if ( ! CanMove(p_hole,newnum) )                                //~v025I~
        return FALSE;                                              //~9C28I~
                                                                   //~0116I~
	if (Mode==MODE_NOINPUT)                                        //~0122R~
    	Mode=MODE_KEYINDATA;                                       //~0116I~
    else                                                           //~0123I~
	if (Mode==MODE_ENDQDATA)                                       //~0123I~
        if (Flags & F_MODEANS)                                     //~0123I~
    		Mode=MODE_KEYINANS;                                    //~0123R~
        else                                                       //~0123I~
    		Mode=MODE_KEYINDATA;	//accept modification          //~0123I~
                                                                   //~0116I~
//    if (Pnum==-1)                                                //~v025R~
//        newnum=CurNum;      //from mouse                         //~v025R~
//    else                                                         //~v025R~
//        newnum=Pnum;                                             //~v025R~
    int num=p_hole->GetNum();                                      //~0101R~
    int addv=1;                                                    //~0101I~
    if (Flags&F_MODEMAKE)    //pattern setting                    //~0116R~
        if (num||newnum==-PATTERN_ID)	//already set or force reset//~0129R~
            p_hole->SetNum(0,0,0);                                 //~0101I~
        else                                                       //~0101I~
            p_hole->SetNum(PATTERN_ID,Mode,0);                     //~0101I~
    else                     //ans mode                            //~0129R~
    	if (num)                                                   //~0123I~
        	if (newnum && (newnum!=num || Pnum!=-1))//accept key even if same//~0129R~
            {                                                      //~0123I~
	            p_hole->SetNum(newnum,Mode,0);                     //~0123R~
                addv=0;		//num chng,no count chng               //~0123I~
			}                                                      //~0123I~
    	    else                                                   //~0123R~
        	    p_hole->SetNum(0,0,0);                             //~0123R~
        else                                                       //~0123I~
        	if (newnum)                                            //~0123I~
	        	p_hole->SetNum(newnum,Mode,0);                     //~0123R~
            else                                                   //~0123I~
            	addv=0;                                            //~0123I~
	if (num)                                                       //~0101I~
    	NumCount-=addv;                                            //~0101R~
    else                                                           //~0101M~
    	NumCount+=addv;                                            //~0101R~
	SetNewNum(by,bx,p_hole,0,0);	//no setans	                   //~0312R~
    if (oldmode!=Mode||NumCount==PEG_MAX||!NumCount)               //~0205R~
        ShowNumBtn();                                              //~0123I~
    return TRUE;                                                   //~9C28I~
}                                                                  //~9C09I~
//===============================================================================//~0205M~
//== chk drop down available                                       //~0205M~
//===============================================================================//~0205M~
//BOOL    Board::CanMove(Hole* pHole)                              //~v025R~
BOOL    Board::CanMove(Hole* pHole,int Pnum)                       //~v025I~
{                                                                  //~0205M~
    if (!(Flags & (F_MODEANS|F_MODEMAKE)))                         //~0205M~
    {                                                              //~v025I~
    	if (Mode==MODE_INIT)                                       //~v025I~
        {                                                          //~v025I~
    		Mode=MODE_NOINPUT;                                     //~v025I~
            if (Pnum==0)                                           //~v025I~
			    Flags|=F_MODEMAKE;                                 //~v025I~
            else                                                   //~v025I~
			    Flags|=F_MODEANS;                                  //~v025I~
            return true;                                           //~v025I~
    	}                                                          //~v025I~
    	return FALSE;                                              //~0205M~
    }                                                              //~v025I~
	if (Flags & F_THREAD)	//running subthread                    //~0205M~
    	return FALSE;                                              //~0205M~
    if (Mode==MODE_OUTANS && !(Flags & F_ERROR))                   //~0205M~
    	return FALSE;                                              //~0205M~
    int state=pHole->GetState();                                   //~0205M~
    if (pHole->GetErr()==HOLE_NEXT)                                //~0205M~
	    return FALSE;                                              //~0205M~
                                                                   //~0205M~
    if (Mode>MODE_ENDQDATA)                                        //~0205M~
    	if (state && state<MODE_ENDQDATA)                          //~0205M~
	    	return FALSE;                                          //~0205M~
    return TRUE;                                                   //~0205M~
}                                                                  //~0205M~
//===============================================================================//~0205I~
//=rc:0:bypass,1:processed(need invalidate),==============================================================================//~0212I~
//===============================================================================//~0212I~
BOOL Board::SetMemo(CPoint point,int Pnum)                         //~0212R~
{                                                                  //~0205I~
    int    bx, by,newnum;                                          //~0213R~
    int    oldmode=Mode;                                           //~0205I~
    if (Pnum==-1)         //mouse                                  //~0205I~
    {                                                              //~0205I~
    	if ( ! ::ScreenToBoard( point.x, point.y, &bx, &by ) )     //~0205I~
        	return FALSE;                // {[h̏ł͂Ȃ//~0205I~
	    KbFocus=by*MAP_SIZE+bx;                                    //~0211R~
	}                                                              //~0205I~
	else                  //kbd input                              //~0205I~
    {                                                              //~0205I~
    	bx=KbFocus%MAP_SIZE;                                       //~0211R~
    	by=KbFocus/MAP_SIZE;                                       //~0211R~
    }                                                              //~0205I~
    Hole*   p_hole= BoardMap[ by ][ bx ];                          //~0205I~
    if (!CanSetMemo(p_hole) )                                      //~0205R~
        return TRUE;                                               //~0213R~
                                                                   //~0205I~
    if (Pnum==-1)                                                  //~0205I~
    	newnum=CurNum;		//from mouse                           //~0205I~
	else                                                           //~0205I~
    	newnum=Pnum;                                               //~0205I~
	if (p_hole->SetMemo(newnum))		//set memo                     //~0213R~
    	CountPenalty(PENALTY_MEMO);                                //~0213I~
    return TRUE;                                                   //~0212R~
}                                                                  //~0205I~
//===============================================================================//~0205I~
//== chk drop down available                                       //~0205I~
//===============================================================================//~0205I~
BOOL    Board::CanSetMemo(Hole* pHole)                             //~0205I~
{                                                                  //~0205I~
    if (Mode!=MODE_KEYINANS && Mode!=MODE_ENDQDATA)                //~0206R~
    	return FALSE;                                              //~0205I~
    if (pHole->GetNum())                                                      //~0212I~
    	return FALSE;                                              //~0212I~
                                                                   //~0212I~
    return TRUE;                                                   //~0205I~
}                                                                  //~0205I~
//===============================================================================//~0205I~
void	Board::SetNewNum(int by,int bx,Hole* phole,int Psortsw,int Psetanssw)//~0312R~
{                                                                  //~0130I~
	if (phole->GetState()<=MODE_ENDQDATA)                               //~0213I~
		pPat->SetNewData(by,bx,phole->GetNum(),Psortsw);           //~0213R~
    else                                                           //~0213I~
    	if (Psetanssw)                                             //~0312I~
		    pPat->SetAnsData(by,bx,phole->GetNum());               //~0312R~
    Flags&=~F_ERROR;                                               //~0130I~
}                                                                  //~0130I~
//===============================================================================//~0205I~
//rc=0:key ignored,1:key processed,-1:key processed but no need to redraw//~0206I~
//===============================================================================//~0206I~
int	Board::KeyProc(UINT nChar)                                     //~0206R~
{                                                                  //~0102I~
	                                                     //~0102I~
	Hole *phole;                                                   //~0206I~
    BOOL rc;                                                       //~0102I~
                                                                   //~0206I~
    if (KbFocus<0 || KbFocus>=PEG_MAX)                             //~0211R~
        return -1;                                                 //~0206R~
                                                                   //~0206I~
	if (nChar>=VK_F1 && nChar<=VK_F10)                             //~0211R~
    {                                                              //~0205I~
        if (Shiftkey)                                              //~0212I~
        	return -1;                                             //~0212I~
    	if (nChar==VK_F10)                                         //~0211R~
    		rc=SetMemo(0,0);                                       //~0212R~
        else                                                       //~0205I~
    		rc=SetMemo(0,nChar-VK_F1+1);                           //~0212R~
        if (!rc)                                                   //~0212I~
        	return -1;                                             //~0212I~
		return 1;                                                  //~0206R~
	}                                                              //~0205I~
	if (nChar>='0' && nChar<='9')                                //~0102I~
    {                                                              //~0102I~
        if (Shiftkey)                                              //~0206R~
			if (nChar=='0')                                        //~0206I~
            	return SetSameNum(0)-1;                            //~0211I~
            else                                                   //~0206I~
            	return SetSameNum('0'-nChar)-1;                    //~0206R~
                    //no chng=-1:no redraw,chng=0:no button but redraw//~0206M~
                                                                   //~0206M~
    	rc=DropDown(0,nChar-'0');                                  //~0102R~
        if (rc)                                                    //~0102I~
        	NextFocus();                                           //~0211R~
		return rc;                                                 //~0102I~
	}                                                              //~0102I~
    if (nChar==VK_SPACE)                                           //~0102I~
    {                                                              //~0102I~
    	rc=DropDown(0,0);                                          //~0102R~
        if (rc)                                                    //~0102I~
        	NextFocus();                                           //~0211R~
		return rc;                                                 //~0102I~
	}                                                              //~0102I~
    int from=KbFocus;                                              //~0211R~
	switch(nChar)                                                  //~0102I~
    {                                                              //~0102I~
    case VK_SHIFT:                                                 //~0206I~
    	Shiftkey=1;                                                //~0206I~
        return -1;      //no need redraw                           //~0206I~
    case VK_HOME:                                                  //~0102I~
    	KbFocus=0;                                                 //~0211R~
        break;                                                     //~0102I~
    case VK_END:                                                   //~0102I~
    	KbFocus=PEG_MAX-1;                                         //~0211R~
        break;                                                     //~0102I~
    case VK_UP:                                                    //~0102I~
        KbFocus-=MAP_SIZE;                                         //~0211R~
        if (KbFocus<0)                                             //~0211R~
        {                                                          //~0102I~
        	KbFocus+=PEG_MAX;                                      //~0211R~
            PrevFocus();                                           //~0211R~
        }                                                          //~0102I~
        break;                                                     //~0102I~
    case VK_DOWN:                                                  //~0102I~
        KbFocus+=MAP_SIZE;                                         //~0211R~
        if (KbFocus>=PEG_MAX)                                      //~0211R~
        {                                                          //~0102I~
        	KbFocus-=PEG_MAX;                                      //~0211R~
            NextFocus();                                           //~0211R~
        }                                                          //~0102I~
        break;                                                     //~0102I~
    case VK_LEFT:                                                  //~0102I~
        PrevFocus();                                               //~0211R~
        break;                                                     //~0102I~
    case VK_RIGHT:                                                 //~0102I~
        NextFocus();                                               //~0211R~
        break;                                                     //~0102I~
    case VK_DELETE:                                                //~0129I~
	    if (Flags&F_MODEMAKE)    //pattern setting                 //~0129I~
    		DropDown(0,-PATTERN_ID);                               //~0129I~
        else                                                       //~0129I~
        {                                                          //~0206I~
        	phole=BoardMap[KbFocus/MAP_SIZE][KbFocus%MAP_SIZE];    //~0211R~
        	if (phole->GetNum())                                   //~0206I~
    			DropDown(0,0);                                     //~0206R~
            else                                                   //~0206I~
    			SetMemo(0,PATTERN_ID);	//map_size:clear id        //~0211R~
        }                                                          //~0206I~
        break;                                                     //~0129I~
    case VK_INSERT:                                                //~0206I~
		return SetSameNum(1)-1;                                    //~0206R~
				//no chng=-1:no redraw,chng=0:no button but redraw //~0206I~
    case VK_BACK:       //back space                               //~0129I~
        PrevFocus();                                               //~0211R~
	    if (Flags&F_MODEMAKE)    //pattern setting                 //~0129I~
    		DropDown(0,-PATTERN_ID);                               //~0129I~
        else                                                       //~0129I~
    		DropDown(0,0);                                         //~0129R~
        break;                                                     //~0129I~
    default:                                                       //~0102I~
    	return -1;                                                 //~0206R~
	}                                                              //~0102I~
    return 1;                                                      //~0206R~
}                                                                  //~0102I~
//===============================================================================//~0206M~
//rc  :TRUE:need to invalidate                                     //~0212R~
//===============================================================================//~0212I~
BOOL    Board::KeyUpProc(UINT nChar)                               //~0211R~
{                                                                  //~0211R~
//    if (Shiftkey)                                                //~0211R~
//        if (nChar>='1' && nChar<='9')                            //~0211R~
//        {                                                        //~0211R~
//            SetSameNum(0);                                       //~0211R~
//            return TRUE;                                         //~0211R~
//        }                                                        //~0211R~
//                                                                 //~0211R~
    switch(nChar)                                                  //~0211R~
    {                                                              //~0211R~
//    case VK_INSERT:                                              //~0211R~
//        SetSameNum(0);                                           //~0211R~
//        break;                                                   //~0211R~
    case VK_SHIFT:                                                 //~0211R~
        Shiftkey=0;                                                //~0211R~
        return FALSE;                                              //~0212I~
//        if (SameNum)                                             //~0211R~
//            SetSameNum(0);                                       //~0211R~
//        break;                                                   //~0211R~
    default:                                                       //~0211R~
        return FALSE;                                              //~0211R~
    }                                                              //~0211R~
    return TRUE;                                                   //~0211R~
}                                                                  //~0211R~
//===============================================================================//~0205I~
void	Board::NextFocus(void)                                     //~0211R~
{                                                                  //~0102I~
	if (++KbFocus>=PEG_MAX)                                        //~0211R~
    	KbFocus=0;                                                 //~0211R~
}                                                                  //~0102I~
//===============================================================================//~0205I~
void	Board::PrevFocus(void)                                     //~0211R~
{                                                                  //~0102I~
	if (--KbFocus<0)                                               //~0211R~
    	KbFocus=PEG_MAX-1;                                         //~0211R~
}                                                                  //~0102I~
//===============================================================================//~0205I~
void Board::SetNum(int Pnum,CWnd *Pview)                          //~0109R~
{                                                                  //~9C28I~
    CurNum=Pnum;                                                   //~9C28I~
    if (Pview)                                                     //~0109I~
    	pView=Pview;                                               //~0109I~
}                                                                  //~9C28I~
//===============================================================================//~0205I~
int Board::GetNum(void)                                            //~9C30I~
{                                                                  //~9C30I~
    return CurNum;                                                 //~9C30I~
}                                                                  //~9C30I~
//===============================================================================//~0205I~
int Board::GetKbFocus()                                            //~0211R~
{                                                                  //~0102M~
	if (KbFocus>=PEG_MAX||KbFocus<0)                               //~0211R~
    	return -1;                                                  //~0102M~
	return KbFocus;                                                //~0211R~
}                                                                  //~0102M~
//===============================================================================//~0206I~
//parm:0:up,1:down,0>:Shift+PFK num down                           //~0211R~
//rc=0:no change,1:status change                                   //~0206I~
//===============================================================================//~0206I~
int Board::SetSameNum(int Pdownsw)                                 //~0206R~
{                                                                  //~0206I~
    int oldnum;                                                    //~0206R~
	oldnum=SameNum;                                                //~0206I~
    if (!Pdownsw)		//clear req                                //~0206I~
    	SameNum=0;                                                 //~0206I~
    else                                                           //~0206I~
    {                                                              //~0206I~
        if (Pdownsw<0)                                             //~0213R~
            SameNum=-Pdownsw;                                      //~0206R~
        else                                                       //~0206R~
            SameNum=CurNum;                                        //~0206R~
    	if (oldnum==SameNum)	//same key pushed                  //~0211I~
        	SameNum=0;                                             //~0211I~
        else                                                       //~0213I~
    	    CountPenalty(PENALTY_SAMENUM);                         //~0213I~
	}                                                              //~0206I~
    return oldnum!=SameNum;                                        //~0206R~
}//setsamenum                                                      //~0213R~
//===============================================================================//~0123R~
Hole::Hole( int board_x, int board_y )
{
    BoardX = board_x;
    BoardY = board_y;
    Num=0;                                                         //~0101R~
    State=0;                                                       //~0101I~
    Err=0; 
	MemoCnt=0;
	memset(Memo,0,sizeof(Memo));//~0101I~
}
//===============================================================================//~0123R~
Hole::~Hole()
{
}
//===============================================================================*///~0205M~
int Hole::GetNum(void)                                             //~0205M~
{                                                                  //~0205M~
    return Num;                                                    //~0205M~
}                                                                  //~0205M~
//===============================================================================//~0123I~
void Hole::SetNum(int Pnum,int Pmode,int Perr)                   //~0101R~
{                                                                  //~9C28I~
	if (Pmode>=0)                                                  //~0109I~
    	State=Pmode;                                               //~0109R~
	if (Pnum>=0)                                                   //~0109I~
    	Num=Pnum;                                                  //~0109R~
                                                                   //~0212I~
	if (Perr>=0)                                                   //~0109I~
    	if (Err>=HOLE_NEXT && Perr==HOLE_ERR)                      //~0212R~
        	Err=HOLE_NEXTERR;                                      //~0212R~
        else                                                       //~0212I~
	    	Err=Perr;                                              //~0212R~
}                                                                  //~9C28I~
//===============================================================================//~0205I~
//num=0:clear first memo,10:clear all memo=====================================//~0211I~
//return:cleared count for all clear;1 if memo changed for other case//~0213I~
//===============================================================================//~0211I~
int  Hole::SetMemo(int Pnum)                                       //~0213R~
{                                                                  //~0205I~
	int ii,jj,rc=0;                                                //~0213R~
	int temp[10];                                                   //~0205I~
    if (Pnum==PATTERN_ID)		//clear req                        //~0211R~
    {                                                              //~0206I~
		memset(Memo,0,sizeof(Memo));                               //~0206I~
        ii=MemoCnt;                                                //~0213I~
		MemoCnt=0;                                                 //~0206I~
        return ii;                                                 //~0213R~
    }                                                              //~0206I~
    if (Pnum<0 || Pnum>9)                                          //~0205I~
    	return 0;                                                  //~0213R~
    if (Pnum)                                                      //~0205I~
    {                                                              //~0205I~
    	for (ii=0;ii<4;ii++)                                       //~0205I~
        	if (Memo[ii]==Pnum)                                    //~0205I~
            {                                                      //~0205I~
            	Memo[ii]=0;	//clear if same num                    //~0213R~
                rc=1;                                              //~0213I~
                break;                                             //~0205I~
			}                                                      //~0205I~
		if (ii==4)   			//new num                          //~0213R~
            for (ii=0;ii<4;ii++)                                   //~0205I~
                if (!Memo[ii])                                     //~0205I~
                {                                                  //~0205I~
                    Memo[ii]=Pnum;                                 //~0205I~
	                rc=1;                                          //~0213I~
                    break;                                        //~0205I~
                }                                                  //~0205I~
	}                                                              //~0205I~
    else	//Pnum==0		//clear first                          //~0211R~
    	for (ii=0;ii<4;ii++)                                       //~0205I~
        	if (Memo[ii])                                          //~0205I~
            {                                                      //~0205I~
            	Memo[ii]=0;                                        //~0205I~
                rc=1;                                              //~0213I~
                break;                                             //~0205I~
			}                                                      //~0205I~
	memset(temp,0,sizeof(temp));                                   //~0205I~
    for (ii=0;ii<4;ii++)                                           //~0205I~
    	temp[Memo[ii]]=1;                                          //~0205I~
	memset(Memo,0,sizeof(Memo));                                   //~0205I~
    for (ii=1,jj=0;ii<10;ii++)                                     //~0205I~
        if (temp[ii])                                              //~0205I~
            Memo[jj++]=ii;                                         //~0205I~
	MemoCnt=jj;                                                    //~0205I~
    return rc;                                                     //~0213I~
}                                                                  //~0205I~
//===============================================================================//~0205I~
BOOL  Hole::GetState()                                             //~0101R~
{                                                                  //~9C28I~
    return State;                                                 //~9C28I~
}                                                                  //~9C28I~
//===============================================================================//~0205I~
int Hole::GetErr()                                                 //~0212R~
{                                                                  //~0205I~
    return Err;                                                    //~0205I~
}                                                                  //~0205I~
//===============================================================================//~0205M~
void    Hole::Show( CDC* pDC,CFont *Pmemofont,BOOL PFocus,int Psamenum,BOOL Pansmode)//~0211R~
{                                                                  //~0205M~
    CFont *oldfont;                                                //~0205I~
	char szNum[2];                                                 //~0205M~
    int x, y,ii;                                                   //~0205I~
                                                                   //~0205I~
    if (Num)                                                       //~0212R~
    {                                                              //~0205M~
    	if (Psamenum==Num)                                         //~0206R~
        	PFocus+=2;                                             //~0211R~
        if (Err==HOLE_ERR||Err==HOLE_NEXTERR)                      //~0212R~
        {                                                          //~0205M~
            ::ShowObject( pDC, BoardX, BoardY, ST_ERR,PFocus);        // <--- I//~0211R~
            pDC->SetTextColor(COL_NUM_E);                          //~0205M~
		}                                                          //~0205M~
        else                                                       //~0205M~
        if (Err==HOLE_NEXT)                                        //~0205M~
        {                                                          //~0205M~
            ::ShowObject( pDC, BoardX, BoardY, ST_NEXT,PFocus);        // <--- I//~0211R~
            pDC->SetTextColor(COL_NUM_NEXT);                       //~0205M~
		}                                                          //~0205M~
        else                                                       //~0205M~
        if (Err==HOLE_RCHK)                                        //~0205M~
        {                                                          //~0205M~
            ::ShowObject( pDC, BoardX, BoardY, ST_RCHK,PFocus);        // <--- I//~0211R~
            pDC->SetTextColor(COL_NUM_RCHK);                       //~0205M~
		}                                                          //~0205M~
        else                                                       //~0205M~
        if (State<=MODE_ENDQDATA)                                  //~0205M~
        {                                                          //~0205M~
            if (Pansmode)                                          //~0212R~
				if (Num==PATTERN_ID)                               //~0212I~
			        ::ShowObject( pDC, BoardX, BoardY,ST_EMPTY,PFocus);        // <--- I//~0212I~
                else                                               //~0212I~
                {                                                  //~0212R~
                    ::ShowObject( pDC, BoardX, BoardY, ST_QDATA,PFocus);    // <--- I//~0212R~
                    pDC->SetTextColor(COL_NUM_Q);                  //~0212R~
                }                                                  //~0212R~
            else                                                   //~0205M~
            {                                                      //~0205M~
                ::ShowObject( pDC, BoardX, BoardY, ST_PAT,PFocus);        // <--- I//~0211R~
                pDC->SetTextColor(COL_NUM_P);                      //~0205M~
            }                                                      //~0205M~
        }                                                          //~0205M~
        else                                                       //~0205M~
        {                                                          //~0205M~
            ::ShowObject( pDC, BoardX, BoardY, ST_ANS,PFocus);        // <--- I//~0211R~
            pDC->SetTextColor(COL_NUM_A);                          //~0205M~
        }                                                          //~0205M~
	}                                                              //~0205M~
	else                                                           //~0205M~
        ::ShowObject( pDC, BoardX, BoardY,ST_EMPTY,PFocus);        // <--- I//~0211R~
//Num Text                                                         //~0205M~
    ::BoardToScreen( BoardX,BoardY, &x, &y );          // `ʒu߂//~0205I~
    if (Num)                                                       //~0212R~
    {                                                              //~0205M~
		pDC->SetBkMode(TRANSPARENT);                               //~0205M~
        if (Num==PATTERN_ID)                                       //~0205M~
        {                                                          //~0205M~
            if (!Pansmode)                                         //~0205M~
	    		*szNum=0;                                          //~0205M~
            else                                                   //~0205M~
                *szNum=' ';                                        //~0205M~
		}                                                          //~0205M~
        else                                                       //~0205M~
            if (!Pansmode)                                         //~0205M~
	    		*szNum=0;                                          //~0205M~
       
		else                                                   //~0205M~
                sprintf(szNum,"%d",Num);                           //~0205M~
		pDC->TextOut(x+NUMTEXT_MARGIN*8,y,szNum,1);                //~0213R~
	}                                                              //~0205M~
	else                                                           //~0205I~
    	if (Pansmode && MemoCnt)                                   //~0205R~
        {                                                          //~0205I~
			pDC->SetBkMode(TRANSPARENT);                           //~0211I~
    		oldfont=pDC->SelectObject(Pmemofont);                  //~0205R~
            pDC->SetTextColor(COL_NUM_A);                          //~0205I~
            for (ii=0;ii<MemoCnt;ii++)                             //~0205I~
            {                                                      //~0205R~
                if (!Memo[ii])                                     //~0205R~
                    break;                                         //~0205R~
                sprintf(szNum,"%d",Memo[ii]);                      //~0205R~
                pDC->TextOut(x+MEMOTEXT_MARGIN*3+(ii%2 ? MEMOTEXT_SIZE-MEMOTEXT_MARGIN:0),//~0213R~
                             y+MEMOTEXT_MARGIN  +(ii/2 ? MEMOTEXT_SIZE-1:0),//~0213R~
								szNum,1);                          //~0211I~
            }                                                      //~0205R~
    		pDC->SelectObject(oldfont);                            //~0205I~
        }                                                          //~0205R~
}                                                                  //~0205M~
//===============================================================================//~0123R~
void    BoardToScreen( int bx, int by, int* px, int* py )
{
    *px = BOARD_LEFT + bx * ( OBJECT_SIZE + GAP );
    *py = BOARD_TOP  + by * ( OBJECT_SIZE + GAP );
}
//===============================================================================//~0123R~
void    ShowObject( CDC* pDC, int bx, int by, OBJ_STAT sts,int PFocus)//~0211R~
{
    int x, y;       // EBhE̎ۂ̍W
    ::BoardToScreen( bx, by, &x, &y );          // `ʒu߂
	CBrush* old_br;                                                //~0102I~
    CBrush  br(OBJ_COLOR[sts]);         // `IuWFNg̐F//~0102R~
    
    if (PFocus)                                                    //~0211R~
    {                                                              //~0102I~
	    CBrush  brFocus(COL_BG_FORCUS);         // `IuWFNg̐F//~0211R~
	    CBrush  snFocus(COL_BG_SAMENUM);        // `IuWFNg̐F//~0211R~
        switch(PFocus)                                             //~0211I~
        {                                                          //~0211I~
        case 3:		//forcus and samenum                           //~0211I~
	    	old_br = pDC->SelectObject( &snFocus);                 //~0211I~
	    	pDC->Rectangle( x, y, x + OBJECT_SIZE, y + OBJECT_SIZE );//~0211I~
	    	pDC->SelectObject( &brFocus);                          //~0211I~
    		pDC->Rectangle( x+2,y+2,x+OBJECT_SIZE-2,y+OBJECT_SIZE-2);//~0211I~
	    	pDC->SelectObject( &br);                               //~0211I~
    		pDC->Rectangle( x+4,y+4,x+OBJECT_SIZE-4,y+OBJECT_SIZE-4);//~0211I~
        	break;                                                 //~0211I~
        case 2:		//samenum                                      //~0211I~
	    	old_br = pDC->SelectObject( &snFocus);                 //~0211I~
	    	pDC->Rectangle( x, y, x + OBJECT_SIZE, y + OBJECT_SIZE );//~0211I~
	    	pDC->SelectObject( &br);                               //~0211I~
    		pDC->Rectangle( x+3,y+3,x+OBJECT_SIZE-3,y+OBJECT_SIZE-3);//~0211R~
        	break;                                                 //~0211I~
        default:    //focus                                        //~0211I~
	    	old_br = pDC->SelectObject( &brFocus);                 //~0211I~
	    	pDC->Rectangle( x, y, x + OBJECT_SIZE, y + OBJECT_SIZE );//~0211I~
	    	pDC->SelectObject( &br);                               //~0211I~
    		pDC->Rectangle( x+2,y+2,x+OBJECT_SIZE-2,y+OBJECT_SIZE-2);//~0213R~
        }                                                          //~0211I~
    }                                                              //~0102I~
    else                                                           //~0102I~
    {                                                              //~0102I~
	    old_br = pDC->SelectObject( &br );                         //~0102R~
    	pDC->Rectangle( x, y, x + OBJECT_SIZE, y + OBJECT_SIZE );  //~0102R~
	}                                                              //~0102I~
    pDC->SelectObject( old_br );
}
//===============================================================================*///~0123R~
BOOL    ScreenToBoard( int wx, int wy, int* pbx, int* pby )        //~9C09I~
{                                                                  //~9C09I~
    int x = wx - BOARD_LEFT;                                       //~9C09I~
    int y = wy - BOARD_TOP;                                        //~9C09I~
    if ( x < 0 || BOARD_WIDTH <= x || y < 0 || BOARD_WIDTH <= y )  //~9C09I~
        return FALSE;                                              //~9C09I~
    int bx = x / ( OBJECT_SIZE + GAP );     // GAP ܂߂{[ḧʒu//~9C09I~
    int by = y / ( OBJECT_SIZE + GAP );                            //~9C09I~
    int obj_x = bx * ( OBJECT_SIZE + GAP ); // ̈ʒũIuWFNg̍̍W//~9C09I~
    int obj_y = by * ( OBJECT_SIZE + GAP );                        //~9C09I~
    if ( obj_x + OBJECT_SIZE - 1 < x || obj_y + OBJECT_SIZE - 1 < y )//~9C09I~
        return FALSE;                                              //~9C09I~
    *pbx = bx;                                                     //~9C09I~
    *pby = by;                                                     //~9C09I~
    return TRUE;                                                   //~9C09I~
}                                                                  //~9C09I~
//=============================================================================//~0123R~
int	Board::GetPath()                                               //~0116R~
{                                                                  //~9C12I~
    int cnt=0;                                                     //~0129I~
    for ( int bx = 0; bx < MAP_SIZE; bx ++ )                       //~0129I~
        for ( int by = 0; by < MAP_SIZE; by ++ )                   //~0129I~
        {                                                          //~0129I~
            Hole *phole=BoardMap[ bx ][ by ];                      //~0129I~
            if (phole->GetNum())                                   //~0129I~
                cnt++;                                             //~0129I~
        }                                                          //~0129I~
    return cnt;                                                    //~0129R~
}                                                                  //~9C12I~
//=============================================================================*///~9C12I~
int	Board::GetMode()                                               //~9C12I~
{                                                                  //~9C12I~
	return Mode;                                                   //~9C12I~
}                                                                  //~9C12I~
//=============================================================================*///~9C31M~
void    Board::OnClear()                                           //~9C31M~
{                                                                  //~9C31M~
    Score=ScoreMax=0;                                              //~0226I~
	if (ErrClear())                                                //~v003R~
    {                                                              //~v003I~
    	SetTempMsg("G[NA[܂");                    //~v003R~
    	return;                                                    //~v003I~
    }                                                              //~v003I~
	if (MemoClear())                                               //~0213I~
    {                                                              //~0213I~
    	SetTempMsg("NA[܂");                      //~0213I~
    	return;                                                    //~0213I~
    }                                                              //~0213I~
    while(TRUE)                                                    //~0103I~
	{                                                              //~0103I~
		if (OnClearSub(1))		//clear current level              //~0116R~
            break;                                                 //~0205R~
        if ((Flags & F_ONTRY))  //I'll try but no input            //~0205M~
        {                                                          //~0205M~
        	Flags&=~F_ONTRY;                                       //~0205M~
            break;                                                 //~0213R~
        }                                                          //~0205M~
        if (OnClearBack())      //reached to first                 //~0205M~
        {                                                          //+v030I~
        	if ((Flags & F_MODEMAKE)!=0)                           //+v030I~
            {                                                      //+v030I~
        		Flags &=~F_MODEMAKE;                               //+v030I~
        		Flags |=F_MODEANS;                                 //+v030I~
            }                                                      //+v030I~
            return;                                                //~0205I~
        }                                                          //+v030I~
	}                                                              //~0103I~
    OnClearBack();                                                 //~0211R~
    while(TRUE)                                                    //~0205I~
	{                                                              //~0205I~
		if (OnClearSub(0))		//chk curr level data exist        //~0205I~
            break;                                                 //~0205I~
        if ((Flags & F_ONTRY))  //I'll try but no input            //~0212I~
        	return;             //step back by next clear          //~0212I~
        if (OnClearBack())      //reached to first                 //~0205I~
            return;                                                //~0205I~
	}                                                              //~0205I~
}                                                                  //~9C31M~
//=============================================================================*///~0103I~
//clear data of a step                                             //~0103I~
//  parm:clear option,0 if chk count                               //~0123R~
//  return count                                                   //~0123R~
//=============================================================================*///~0103I~
int Board::OnClearSub(int Popt)                                    //~0116R~
{                                                                  //~0103I~
    Hole*    p_hole;                                               //~0103I~
    int      cnt=0,state;                                          //~0108R~
    for ( int bx = 0; bx < MAP_SIZE; bx ++ )                       //~0103I~
        for ( int by = 0; by < MAP_SIZE; by ++ )                   //~0103I~
        {                                                          //~0103I~
            p_hole = BoardMap[ by ][ bx ];                         //~0103I~
            p_hole->SetMemo(PATTERN_ID);    //clear all memo       //~0211I~
            if (p_hole->GetNum())                                  //~0103I~
            {                                                      //~0108I~
                state=p_hole->GetState();                          //~0108R~
                if (state==Mode)                                   //~0116R~
                {                                                  //~0103I~
                	cnt++;                                         //~0103I~
                    if (Popt)                                      //~0103I~
                    {                                              //~0103I~
                    	NumCount--;                                //~0103I~
                    	p_hole->SetNum(0,0,0);                     //~0103I~
						SetNewNum(by,bx,p_hole,0,1);               //~0312R~
                    }                                              //~0103I~
                }                                                  //~0103I~
			}                                                      //~0108I~
        }                                                          //~0103I~
	return cnt;
}                                                                  //~0103I~
//=============================================================================*///~v003I~
//clear err only                                                   //~v003I~
//  return cleared err count                                       //~v003I~
//=============================================================================*///~v003I~
int Board::ErrClear()                                              //~v003I~
{                                                                  //~v003I~
    Hole*    p_hole;                                               //~v003I~
    int      cnt=0;                                                //~v003I~
    for ( int bx = 0; bx < MAP_SIZE; bx ++ )                       //~v003I~
        for ( int by = 0; by < MAP_SIZE; by ++ )                   //~v003I~
        {                                                          //~v003I~
            p_hole = BoardMap[ by ][ bx ];                         //~v003I~
            if (p_hole->GetErr()==HOLE_ERR)                        //~v003R~
            {                                                      //~v003I~
            	cnt++;                                             //~v003I~
                NumCount--;                                        //~v003I~
	            p_hole->SetNum(0,0,0);                             //~v003I~
            }                                                      //~v003I~
        }                                                          //~v003I~
    Flags&=~F_ERROR;                                               //~v003R~
	return cnt;                                                    //~v003I~
}                                                                  //~v003I~
//=============================================================================*///~0213I~
//clear all memo data                                              //~0213I~
//  return cleared memo count                                      //~0213I~
//=============================================================================*///~0213I~
int Board::MemoClear()                                             //~0213I~
{                                                                  //~0213I~
    Hole*    p_hole;                                               //~0213I~
    int      cnt=0;                                                //~0213I~
    for ( int bx = 0; bx < MAP_SIZE; bx ++ )                       //~0213I~
        for ( int by = 0; by < MAP_SIZE; by ++ )                   //~0213I~
        {                                                          //~0213I~
            p_hole = BoardMap[ by ][ bx ];                         //~0213I~
            cnt+=p_hole->SetMemo(PATTERN_ID);    //clear all memo  //~0213I~
        }                                                          //~0213I~
	return cnt;                                                    //~0213I~
}                                                                  //~0213I~
//=============================================================================*///~0103I~
//mode back; return 1 when reached to first step                   //~0103I~
//=============================================================================*///~0103I~
int Board::OnClearBack()                                           //~0103R~
{                                                                  //~0103I~
    switch(Mode)                                                   //~0103I~
    {
	case MODE_INIT:                                                //~0116R~
	case MODE_NOINPUT:                                             //~0205I~
    case MODE_FILEDATA:                                            //~0116R~
        sProbLevel="";                                             //~0213I~
        return 1;                                                  //~0103R~
    case MODE_KEYINDATA:                                           //~0116R~
        if (NumCount)                                              //~0205I~
	        Mode=MODE_FILEDATA;                                    //~0205R~
        else                                                       //~0205I~
	        Mode=MODE_NOINPUT;                                     //~0205I~
        Score=0;                                                   //~0213I~
        TryTimeSpan=0;                                             //~0213I~
        break;                                                     //~0103I~
    case MODE_ENDQDATA:                                            //~0116R~
        Mode=MODE_KEYINDATA;                                       //~0116I~
        break;                                                     //~0116I~
    case MODE_KEYINANS:                                            //~0116I~
        Mode=MODE_ENDQDATA;                                        //~0123R~
        break;                                                     //~0103I~
    case MODE_OUTANS:                                              //~0116R~
        Mode=MODE_KEYINANS;                                        //~0116I~
        FixedSeq=MaxFixed=0;   //strat solution                    //~0116I~
        break;                                                     //~0116I~
    }                                                              //~0103I~
    return 0;                                                      //~0103I~
}                                                                  //~0103I~
//**************************************************************** //~0116I~
void Board::OnAnswer()                                             //~9C31M~
{                                                                  //~9C31M~
    Score=ScoreMax=0;                                              //~0226I~
	while(Mode>MODE_KEYINDATA)                                     //~0123R~
    {                                                              //~0123I~
    	OnClearSub(1);		//clear the level                      //~0123R~
        OnClearBack();      //level back                           //~0123I~
    }                                                              //~0123I~
    if (Mode==MODE_INIT)                                           //~0116I~
    	Mode=MODE_NOINPUT;                                        //~0116I~
    Flags|=F_MODEANS;                                              //~0116I~
    Flags&=~F_MODEMAKE;                                            //~0116I~
}                                                                  //~9C31M~
//**************************************************************** //~0116I~
void Board::OnMake()                                               //~9C31M~
{                                                                  //~9C31M~
    Score=ScoreMax=0;                                              //~0226I~
	while(Mode>MODE_KEYINDATA)                                     //~0123R~
    {                                                              //~0123I~
    	OnClearSub(1);		//clear the level                      //~0123I~
        OnClearBack();      //level back                           //~0123I~
    }                                                              //~0123I~
    if (Mode==MODE_INIT)                                           //~0116I~
//  	Mode==MODE_NOINPUT;                                        //~v004R~
    	Mode=MODE_NOINPUT;                                         //~v004I~
    Flags&=~F_MODEANS;                                             //~0116I~
    Flags|=F_MODEMAKE;                                             //~0116I~
                                                                   //~0116M~
}                                                                  //~9C31M~
//**************************************************************** //~0116I~
void Board::OnSetend(int Pendthreadsw)                             //~0130R~
{                                                                  //~0116I~
    if (Pendthreadsw)                                              //~0213R~
    {                                                              //~0213R~
        if (Flags & F_ERROR)    //no solution                      //~0213R~
            return;                                                //~0213R~
        SaveAnswerXnp();                                           //~0312I~
        TryStartTime=CTime::GetCurrentTime();                      //~0213M~
        pView->SetTimer(IDC_SETEND,60000,NULL);   //1 min frequency//~0213M~
        sSuccessMsg="";                                            //~0213R~
        SetTempMsg("");                                            //~0213R~
        Npwtryans=Npworkt;		//save for score                   //~0213I~
        CalcScore();        //get max score                        //~0226I~
        Score=0;                                                   //~0226I~
    	if (Flags&F_READFILE)                                      //~v012I~
        {                                                          //~v012I~
	    	Flags&=~F_READFILE;                                    //~v012I~
			Restoreprevinput( );                                   //~v012I~
        }                                                          //~v012I~
    }                                                              //~0213R~
    else                                                           //~0213R~
    {                                                              //~0213R~
    	pView->KillTimer(IDC_SETEND);	//confirmation             //~0213I~
        if (!CurNum)                                               //~0130R~
            CurNum=1;                                              //~0130R~
        Mode=MODE_ENDQDATA;                                        //~0130R~
		pPat->ClearAnsData();                                      //~0213I~
        Penalty=0;			//reset penalty                        //~0213I~
        CallAns(0,0);                                              //~0213I~
    }                                                              //~0213R~
}                                                                  //~0116I~
//**************************************************************** //~0109I~
//*ret :0:ok(set all):1 ok(more step),-1:err                       //~0116R~
//**************************************************************** //~0109I~
int Board::GetSol(int Pendthreadsw)                                //~0205R~
{                                                                  //~9C31I~
	int rc=0,opt;                                                //~0129R~
	if (Mode!=MODE_OUTANS)                                         //~0116R~
    {                      
    	if (!Pendthreadsw)                                         //~0122I~
        {                                                          //~0122I~
        	if (Flags & F_ONRCHK)                                  //~0122R~
//      		opt=XNP_REDUNDANTCK;                               //~v022R~
        		opt=XNP_REDUNDANTCK|XNP_RLEVELMASK;                //~v022I~
            else                                                   //~0130I~
            	opt=0;                                             //~0130I~
        	if (!CallAns(opt,0))                                   //~0205R~
                return 0;                                          //~0123I~
        	return -1;                                             //~0123I~
        }                                                          //~0122I~
    }                                                              //~0108I~
//mode answer                                                      //~0123I~
    if (MaxFixed==PEG_MAX)                                         //~0129R~
        if (FixedSeq<MaxFixed)                                     //~0129I~
        {                                                          //~0129R~
            FixedSeq++;                                            //~0129R~
            SetNextAnswer(FixedSeq);                               //~0129R~
            if (FixedSeq<MaxFixed)                                 //~0129R~
                rc=1;                                              //~0129R~
            else                                                   //~0129I~
		        SaveAnswer();                                      //~0129I~
        }                                                          //~0129R~
    return rc;                                                     //~0109R~
}                                                                  //~9C31I~
//**************************************************************** //~0205I~
void Board::OnNext(int Pendthreadsw)                               //~0205I~
{                                                                  //~0205I~
    PNPWORKT pnpwt;
	PM99 pm99;//~0205I~
	int rc=0,ii,idatano,bx,by;
static int	Stempdata[PEG_MAX];                      //~0205I~
//mode answer                                                      //~0205I~
    if (!Pendthreadsw)                                             //~0205I~
    {                                                              //~0205I~
        if (Mode<MODE_ENDQDATA)                                         //~0205I~
            Mode=MODE_ENDQDATA;                                         //~0205I~
//set curr data as init data                                       //~0205I~
    	for (bx=0,ii=0; bx < MAP_SIZE; bx ++ )                        //~0205I~
        	for (by=0; by < MAP_SIZE; by ++ )                    //~0205I~
            	Stempdata[ii++]=BoardMap[bx][by]->GetNum();         //~0205I~
                                                                   //~0205I~
        CallAns(0,Stempdata);                                       //~0205I~
        return;                                                    //~0205I~
    }                                                              //~0205I~
//*endthread                                                       //~0205I~
    pnpwt=&Npworkt;                                                //~0205I~
    idatano=pnpwt->idatano;                                        //~0205I~
    if (MaxFixed!=PEG_MAX)	//err                                  //~0205R~
    {                                                              //~0205I~
        SetTempMsg("𓚂Ɍ肪L܂");                        //~v003R~
    	return;                                                    //~0205I~
    }                                                              //~0205I~
    for (bx = 0; bx < MAP_SIZE; bx ++ )                            //~0205I~
    {                                                              //~0205I~
        for (by = 0; by < MAP_SIZE; by ++ )                        //~0205I~
        {                                                          //~0205I~
            pm99=&pnpwt->m99[bx][by];     //answer                 //~0205I~
            if (pm99->fnum)                                        //~0205I~
                if (pm99->fseq==idatano+1)                         //~0205I~
                    break;                                         //~0205I~
        }                                                          //~0205I~
        if (by<MAP_SIZE)                                           //~0205I~
            break;                                                 //~0205I~
    }                                                              //~0205I~
    if (bx>=MAP_SIZE)                                              //~0205I~
    	return;                                                    //~0205I~
    KbFocus=bx*MAP_SIZE+by;                                        //~0211R~
    FixedSeq=pm99->fseq;                                           //~0205I~
    DropDown(0,pm99->fnum);                                         //~0205I~
    bx=KbFocus%MAP_SIZE;                                           //~0211R~
    by=KbFocus/MAP_SIZE;                                           //~0211R~
    BoardMap[ by ][ bx ]->SetNum(-1,-1,HOLE_NEXT);                 //~0205I~
    SetTempMsg("Ok");                                              //~0205I~
    return;                                                        //~0205I~
}                                                                  //~0205I~
//**************************************************************** //~0122I~
void Board::OnGo(int Pendthreadsw)                                 //~0122R~
{                                                                  //~9C31I~
	if (Flags&F_MODEANS)                                           //~0116R~
    {                                                              //~0109I~
    	if (NumCount==PEG_MAX)                                     //~0205R~
        {                                                          //~0130I~
        	if (CheckAnswer(1))                                    //~0312R~
		    	CountPenalty(PENALTY_ERR);                         //~0312I~
            Flags&=~F_ONGO;                                        //~0130I~
		}                                                          //~0130I~
        else                                                       //~0129I~
            if (GetSol(Pendthreadsw)==1)       //more step         //~0205R~
                pView->SetTimer(IDC_GO,50,NULL);   //50 ms frequency//~0129R~
            else          //first start thread or err at endthread //~0130R~
            	if (Flags & F_ERROR)//from                         //~0130I~
                	Flags&=~F_ONGO;                                //~0130R~
    }                                                              //~0109I~
    else                                                           //~0109I~
	if (Flags&F_MODEMAKE)                                          //~0116R~
    {                                                              //~0123I~
        if (CallMake())                                            //~0123R~
        	Flags&=~F_ONGO;                                        //~0123I~
	}                                                              //~0123I~
    else                                                           //~0109I~
        SetTempMsg("ݒ肵Ă");                        //~v003R~
    	                                                           //~0109I~
}                                                                  //~9C31I~
//**************************************************************** //~0122I~
void Board::OnStop()                                               //~0110I~
{                                                                  //~0110I~
	if (!(Flags&F_THREAD))                                       //~0110I~
    	return;                                                    //~0110I~
	GblSubthreadStopReq=1;                                         //~0110I~
}                                                                  //~0110I~
//**************************************************************** //~0122I~
//*ret 1:req sw to ans mode(make normal end)                       //~v002I~
//**************************************************************** //~v002I~
int  Board::OnEndThread()                                          //~v002R~
{                                                                  //~0109I~
    PM99 pm99;
    PNPWORKT pnpwt=&Npworkt;                                       //~0122I~
                                                                   //~0109I~
	Flags&=~F_THREAD;                                              //~0109I~
    if (NpsubRc && !GblSubthreadStopReq)                           //~0205R~
        Flags|=F_ERROR;                                            //~0130I~
	                                                               //~0110I~
	if (Flags & F_MODEMAKE)                                       //~0122I~
    {                                                              //~0122R~
    	pPat->Seed=ActSeed;                                        //~0129I~
		Flags&=~F_ONGO;                                            //~0123I~
        if (NpsubRc)                                               //~0122R~
            return 0;                                              //~v002R~
        NumCount=0;                                                //~0205R~
        for ( int bx = 0; bx < MAP_SIZE; bx ++ )                   //~0122R~
            for ( int by = 0; by < MAP_SIZE; by ++ )               //~0122R~
            {                                                      //~0122R~
                Hole *phole=BoardMap[ bx ][ by ];                  //~0122R~
                pm99=&pnpwt->m99[bx][by];     //answer             //~0122R~
                if (pm99->fnum && pm99->dlvl==LEVEL_INIT)          //~0129R~
                {                                                  //~0205I~
                    phole->SetNum(pm99->fnum,MODE_KEYINDATA,0);    //~0129R~
                    NumCount++;                                    //~0205I~
				}                                                  //~0205I~
                else                                               //~0129I~
                    phole->SetNum(0,0,0);                          //~0129I~
				SetNewNum(bx,by,phole,0,1);                        //~0312R~
            }                                                      //~0122R~
        FixedSeq=pnpwt->idatano;                                   //~0122R~
        Mode=MODE_ENDQDATA;                                        //~0122R~
        return 1;                                                  //~v002R~
    }                                                              //~0122I~
//answer end                                                       //~0122I~
    if (Flags & F_ONNEXT)                                          //~0205M~
    {                                                              //~0213I~
	    MaxFixed=pnpwt->seqno;                                     //~0213I~
		OnNext(1);				//advance a step                   //~0205M~
    }                                                              //~0213I~
    else                                                           //~0205M~
    if (Flags & F_ONTRY)                                           //~0213I~
        OnSetend(1);                                               //~0213I~
    else                                                           //~0213I~
    {                                                              //~0205I~
	    MaxFixed=pnpwt->seqno;                                     //~0213I~
    	SetAllAnswer();                                            //~0205R~
    	if (Flags & F_ONRCHK)                                      //~0205R~
			OnRchk(1);		//answer thread end                    //~0205R~
    	else                                                       //~0205R~
            OnGo(1);                //answer thread end,kick timer //~0213R~
	}                                                              //~0205I~
    return 0;                                                      //~v002R~
}//OnEndThread                                                     //~0205R~
//**************************************************************** //~0122I~
//*return elapsed time                                             //~0212I~
//**************************************************************** //~0212I~
int  Board::OnTimer(UINT Pid)                                      //~0212R~
{                                                                  //~0109I~
    CTime ctime;                                                   //~0212I~
	CTimeSpan  ts;                                                 //~0212I~
    int   span=0;                                                  //~0212R~
                                                                   //~0212I~
	if (Pid==IDC_GO)                                               //~0109I~
    {                                                              //~0109I~
		if (!(Flags & F_ONGO))                                      //~0110I~
        	return 0;                                                //~0110I~
		if (!GetSol(1))		//reached to last answer               //~0205R~
        {                                                          //~0109I~
    		pView->KillTimer(IDC_GO);                              //~0109I~
        	Flags&=~F_ONGO;                                        //~0109I~
		}                                                          //~0109I~
	}                                                              //~0109I~
    else                                                           //~0109I~
	if (Pid==IDC_MAKE||Pid==IDC_ANSWER)                            //~0122R~
    {                                                              //~0109I~
		if (!(Flags & F_THREAD))                                    //~0110I~
        	return 0;                                                //~0110I~
		if (!Timeout)                                              //~0110I~
        	return 0;                                                //~0110I~
        ctime=CTime::GetCurrentTime();                             //~0212R~
		ts=ctime-StartTime;                                        //~0212I~
        if (ts.GetTotalSeconds()>Timeout)                          //~0212R~
			GblSubthreadStopReq=2;                                 //~0110R~
	}                                                              //~0109I~
    else                                                           //~0212I~
	if (Pid==IDC_SETEND)                                           //~0212I~
    {                                                              //~0212I~
		if (Flags & F_ONTRY)                                      //~0212I~
        {                                                          //~0212I~
	        ctime=CTime::GetCurrentTime();                         //~0212I~
			ts=ctime-TryStartTime;                                 //~0212I~
			span=TryTimeSpan=ts.GetTotalSeconds();                 //~0212R~
        }                                                          //~0212I~
        else                                                       //~0212I~
    		pView->KillTimer(IDC_SETEND);                          //~0212I~
	}                                                              //~0212I~
    else                                                           //~0212I~
	if (Pid==IDC_SUCCESS)                                          //~0211I~
    	span=OnSuccess();                                          //~0212R~
	return span;                                                   //~0212I~
}//OnTimer                                                         //~0212R~
//**************************************************************** //~0122I~
void Board::OnRchk(int Pendthreadsw)                                //~0122R~
{                                                                  //~9C31I~
	int *pi,cnt,ii,bx,by;                                          //~0109I~
    CString s;                                                     //~0109I~
    if (!Pendthreadsw)                                             //~0122I~
    {	                                                           //~0122I~
    	if (!GetSol(0))	//submitted                                //~0205R~
    		return;			//wait thread comp                     //~0122R~
    	Flags&=~F_ONRCHK;                                          //~0122I~
        return;                                                    //~0122I~
    }                                                              //~0122I~
    if (!NpsubRc)       //no err                                  //~0122R~
    {                                                              //~0109I~
	    cnt=Npworkt.rclistcnt;                                      //~0109I~
        s.Format("璷x [= %d, [P %d ӏ.",Npworkt.rclevel,cnt);//~v023R~
        SetTempMsg(s);                                             //~0109I~
        if (cnt)                                                   //~0109I~
        {                                                          //~0109I~
            pi=Npworkt.rclist;                                      //~0109I~
            for (ii=0;ii<cnt;ii++)                                 //~0109I~
            {                                                      //~0109I~
            	bx=*pi++;                                           //~0109I~
            	by=*pi++;                                           //~0109I~
                BoardMap[ bx ][ by ]->SetNum(-1,-1,HOLE_RCHK);	//redundancy err//~0122R~
            }                                                      //~0109I~
        }                                                          //~0109I~
    }                                                              //~0109I~
    Flags&=~F_ONRCHK;                                               //~0109I~
}                                                                  //~9C31I~
//**************************************************************** //~0130I~
BOOL Board::OnSort()                                               //~0212R~
{                                                                  //~0130I~
    Hole *phole;                                                   //~0130R~
    int  num,bx,by,pdata[MAP_SIZE][MAP_SIZE],rc=0;                 //~0130I~
//*********                                                        //~0130I~
    for (bx = 0; bx < MAP_SIZE; bx ++ )                            //~0130I~
        for (by = 0; by < MAP_SIZE; by ++ )                        //~0130I~
        {                                                          //~0130I~
            num=BoardMap[bx][by]->GetNum();                        //~0130I~
            if (num<0 || num >9)                                   //~0130I~
            	rc=4;                                              //~0130I~
            pdata[bx][by]=num;                                     //~0130I~
		}                                                          //~0130I~
    if (!rc)                                                       //~0130I~
		rc=xnpsortdata((int*)pdata,(int*)pPat->QuestionData);      //~0131R~
    if (rc)                                                        //~0130I~
    {                                                              //~0130I~
    	SetTempMsg("ł܂");                              //~0130R~
        return FALSE;                                              //~0212R~
	}                                                              //~0130I~
//set sorted data                                                  //~0130I~
    for (bx = 0; bx < MAP_SIZE; bx ++ )                            //~0130I~
        for (by = 0; by < MAP_SIZE; by ++ )                        //~0130I~
        {                                                          //~0130I~
            phole=BoardMap[bx][by];                                //~0130R~
            phole->SetNum(pdata[bx][by],-1,-1);	//replace number   //~0130I~
            if (pPat->QuestionData[bx][by])                        //~0130I~
				SetNewNum(bx,by,phole,1,1);//sort option           //~0312R~
        }                                                          //~0130I~
	if (pPat->Datasw & DATA_ANS)	//answer avail                 //~v002I~
		SaveAnswer();                                              //~v002I~
	return TRUE;                                                   //~0212I~
}                                                                  //~0130I~
//**************************************************************** //~0213I~
void Board::CountPenalty(int Ppenalty)                             //~0213I~
{                                                                  //~0213I~
    Penalty+=Ppenalty;                                             //~0213I~
}                                                                  //~0213I~
//**************************************************************** //~0213I~
void Board::CalcScore(void)                                        //~0213I~
{                                                                  //~0213I~
    PM99 pm99;                                                     //~0213I~
    PNPWORKT pnpwt=&Npwtryans;                                     //~0213R~
    int level,score;                                               //~0226R~
    int err,errall=0;                                              //~v024I~
                                                                   //~0213I~
	Score=0;                                                       //~0213I~
	ScoreMax=0;                                                    //~0213I~
    for (int bx = 0; bx < MAP_SIZE; bx ++ )                        //~0213I~
        for (int by = 0; by < MAP_SIZE; by ++ )                    //~0213I~
        {                                                          //~0213I~
		    pm99=&pnpwt->m99[bx][by];     //answer                 //~0213I~
            if (pm99->dlvl!=LEVEL_INIT)                  //q data  //~0213R~
            {   
				level=pm99->dlvl>>8;//~0213I~
                score=0;                                           //~0226I~
                switch(level)                                      //~0226I~
                {                                                  //~0226I~
                case LEVEL_EASY_F:                                 //~0226R~
                    score=5;                                       //~0226I~
                    break;                                         //~0226I~
                case LEVEL_MEDIUM_F:                               //~0226R~
                    score=50;                                      //~0226I~
                    break;                                         //~0226I~
                case LEVEL_HARD_F:                                 //~0226R~
                    score=300;                                     //~0226R~
                    break;                                         //~0226I~
                case LEVEL_HARDP1_F:                               //~0226R~
                    score=400;                                     //~0226R~
                    break;                                         //~0226I~
                case LEVEL_HARDP2_F:                               //~0226R~
                    score=500;                                     //~0226R~
                    break;                                         //~0226I~
                }                                                  //~0226I~
            	ScoreMax+=score;                                   //~0226R~
//  	    	if (BoardMap[bx][by]->GetErr()!=HOLE_NEXT)	//by next key//~v024R~
		    	err=BoardMap[bx][by]->GetErr();                    //~v024R~
		    	if (err==HOLE_PENDDATA)	//by next key              //~v024I~
                	errall=1;                                      //~v024I~
                else                                               //~v024I~
		    	if (err!=HOLE_NEXT)	//by next key                  //~v024I~
            		Score+=score;                                  //~0226R~
			}                                                      //~0213I~
        }                                                          //~0213I~
    if (errall)                                                    //~v024I~
    	Score+=pPat->Score;                                        //~v024I~
	Score-=Penalty;                                                //~0226M~
    int min5=(TryTimeSpan+300)/300;		//by 5 min                 //~0213I~
    if (min5>PENALTY_NOTIME)                                       //~0226I~
        Score-=(min5-PENALTY_NOTIME)*PENALTY_TIME;                 //~0226I~
    if (!Score)                                                     //~0213I~
    	Score=1;                                                   //~0213I~
}//CalcScore                                                       //~0213I~
//************************************************************     //~0122I~
int Board::CallAns(int Poption,int *Ppdata)                        //~0205R~
{                                                                  //~0122I~
static int  opt,level,den,*pdata,rc;                               //~0122I~
static int  tmsgfreq=1000;		//time msg frequency               //~0122I~
static int  repeatmax=ANS_TIMEOUT;  	//loop max                 //~0122I~
static void *plist[8];                                             //~0122I~
static char *rcmsg;                                                //~0122I~
                                                                   //~0122I~
                                                                   //~0122I~
    if (!(pdata=Ppdata))                                           //~0205I~
    {                                                              //~0205I~
		pdata=(int*)(void*)(pPat->QuestionData);                   //~0205R~
		ResetErr(1);	//clear also HOLE_NEXT                     //~0205I~
	}                                                              //~0205I~
    else                                                           //~0205I~
		ResetErr(0);    //leave HOLE_NEXT                          //~0205I~
    memset(&Npworkt,0,sizeof(Npworkt));                            //~0122I~
                                                                   //~0122I~
    opt=(XNP_PILOT|XNP_PILOTNOMSG|XNP_NOPRINTIN|XNP_NOPRINTOUT);   //~0130I~
	opt|=Poption;                                                  //~0130R~
	opt&=XNP_SOLVMASK;                                             //~0130I~
                                                                   //~0122I~
	plist[0]=this;                                                 //~0122I~
	plist[1]=&opt;                                                 //~0122I~
	plist[2]=pdata;                                                //~0122I~
	plist[3]=&Npworkt;                                             //~0122I~
	plist[4]=&tmsgfreq;                                            //~0122I~
	plist[5]=&repeatmax;                                           //~0122I~
	plist[6]=&NpsubRc;                                             //~0122I~
	plist[7]=&rcmsg;                                               //~0122I~
                                                                   //~0122I~
    NpsubRc=0;                                                     //~0122I~
                                                                   //~0122I~
	pThread=AfxBeginThread(AnsThread,plist);                       //~0122I~
	if (pThread)                                                   //~0122I~
    {                                                              //~0122I~
        SetTempMsg("𓚊Jn");                                    //~0122I~
    	Flags|=F_THREAD;                                           //~0122I~
        StartTime=CTime::GetCurrentTime();                         //~0122I~
    	pView->SetTimer(IDC_ANSWER,ANS_MSGFREQ*1000,NULL);   //5 sec ms frequency//~0122I~
        rc=0;                                                      //~0122I~
//        if (Mode==MODE_KEYINANS)                                 //~0205R~
//            Flags|=F_ANSCHK;    //answer chk                     //~0205R~
//        else                                                     //~0205R~
//            Flags&=~F_ANSCHK;                                    //~0205R~
        	                                                       //~0123I~
	}                                                              //~0122I~
	else                                                           //~0122I~
    {                                                              //~0122I~
    	SetTempMsg("Xbh쐬Ɏs܂");                  //~0122I~
        rc=4;                                                      //~0122I~
	}                                                              //~0122I~
    return rc;                                                     //~0122I~
}                                                                  //~0122I~
UINT AnsThread(LPVOID Plist)                                       //~0122I~
{                                                                  //~0122I~
	void **plist=(void**)Plist;                                    //~0122I~
	Board *pBoard=(Board*)plist[0];                                //~0122I~
    CWnd  *pview=pBoard->pView;                                    //~0122I~
	int   opt=*(int*)plist[1];                                     //~0122I~
	int *pdata=(int*)plist[2];                                     //~0122I~
	PNPWORKT pnpwt=(PNPWORKT)plist[3];                             //~0122I~
	int tmsgfreq=*(int*)(plist[4]);                                //~0122I~
	int repeatmax=*(int*)plist[5];                                 //~0122I~
	int *prc=(int*)plist[6];                                       //~0122I~
	char *rcmsg=(char*)plist[7];                                   //~0122I~
                                                                   //~0122I~
    try                                                            //~0122I~
    {                                                              //~0122I~
    	GblSubthreadsw=1;                                          //~0122I~
		GblSubthreadStopReq=0;                                     //~0122I~
    	GblUerrexitsw=0;                                           //~0122I~
	    GblNpsubMsg=0;                                             //~0122I~
                                                                   //~0122I~
		*prc=xnpgetanswer(opt,pdata,pnpwt,tmsgfreq,repeatmax);     //~0122I~
		pBoard->Npsuberr1(*prc);                                   //~0122I~
	}                                                              //~0122I~
    catch(CException E){pBoard->Npsuberr2(&E);}                    //~0122I~
    catch(...)    {pBoard->Npsuberr3();}                           //~0122I~
    pview->KillTimer(IDC_ANSWER);                                   //~0122I~
	pview->PostMessage(WM_COMMAND,IDC_ENDTH);                      //~0122I~
    return 0;                                                      //~0122I~
}                                                                  //~0122I~
int Board::CallMake()                                              //~0123R~
{                                                                  //~0109I~
static int  opt,level,den,*pdata,rc;                               //~0123R~
static int  tmsgfreq=1000;		//time msg frequency               //~0109R~
static int  repeatmax=0x0fffffff;  	//loop max                     //~0110R~
static int  plan=9;	//search pos from max candidate                //~0109R~
static void *plist[13];                                            //~0109I~
static char *rcmsg;                                                //~0109I~
                                                                   //~0109I~
                                                                   //~0109I~
    pPat->Seed=ActSeed=0;                                          //~0129I~
	ResetErr(1);                                                   //~0205R~
    if (pPat->ChkData())                                         //~0109I~
	    pdata=(int*)(void*)(pPat->QuestionData);                   //~0109R~
	else                                                           //~0109I~
    	pdata=0;			//no pattern data                      //~0109I~
    memset(&Npworkt,0,sizeof(Npworkt));                            //~0109I~
                                                                   //~0110I~
	opt=0;                                                         //~0110I~
    if (Flags & F_RIGID)                                           //~0110I~
	    opt|=XNP_RIGID;                                            //~0110R~
	opt&=XNP_MAKEMASK;                                             //~0109I~
                                                                   //~0109I~
    if (Flags & F_LVL1)                                            //~0109I~
    	level='E';                                                 //~0109I~
    else                                                           //~0109I~
    if (Flags & F_LVL2)                                            //~0109I~
    	level='M';                                                 //~0109I~
    else                                                           //~0109I~
    if (Flags & F_LVL3)                                            //~0109I~
    	level='H';                                                 //~0109I~
    else                                                           //~0109I~
    	level=0;                                                   //~0109I~
                                                                   //~0109I~
    if (Flags & F_DEN3)                                            //~0109I~
    	den=3;                                                     //~0109I~
    else                                                           //~0109I~
    if (Flags & F_DEN4)                                            //~0109I~
    	den=4;                                                     //~0109I~
    else                                                           //~0109I~
    if (Flags & F_DEN5)                                            //~0109I~
    	den=5;                                                     //~0109I~
    else                                                           //~0109I~
    	den=SETMAX;                                                //~0129R~
                                                                   //~0109I~
	plist[0]=this;                                                 //~0109I~
	plist[1]=&opt;                                                 //~0109I~
	plist[2]=&Npworkt;                                             //~0109I~
	plist[3]=pdata;                                                //~0109I~
	plist[4]=&den;                                                 //~0109I~
	plist[5]=&tmsgfreq;                                            //~0109I~
	plist[6]=&repeatmax;                                           //~0109I~
	plist[7]=&Seed;                                                //~0109I~
	plist[8]=&plan;                                                //~0109I~
	plist[9]=&level;                                               //~0109I~
	plist[10]=&ActSeed;                                            //~0109I~
	plist[11]=&NpsubRc;                                            //~0109I~
	plist[12]=&rcmsg;                                              //~0109I~

    NpsubRc=0;                                                 //~0110I~

	pThread=AfxBeginThread(MakeThread,plist);                  //~0109I~
	if (pThread)                                                   //~0109I~
    {                                                              //~0109I~
        SetTempMsg("쐬Jn");                                    //~0110R~
    	Flags|=F_THREAD;                                           //~0109I~
        StartTime=CTime::GetCurrentTime();                         //~0109I~
    	pView->SetTimer(IDC_MAKE,5000,NULL);   //5 sec ms frequency//~0109I~
        rc=0;                                                      //~0123I~
	}                                                              //~0109I~
	else                                                           //~0109I~
    {                                                              //~0123I~
    	SetTempMsg("Xbh쐬Ɏs܂");                  //~0109I~
        rc=4;                                                      //~0123I~
    }                                                              //~0123I~
    return rc;                                                     //~0123I~
}                                                                  //~0109I~
UINT MakeThread(LPVOID Plist)                                      //~0109I~
{
	void **plist=(void**)Plist;
	Board *pBoard=(Board*)plist[0];                                //~0109I~
    CWnd  *pview=pBoard->pView;                                    //~0109I~
	int   opt=*(int*)plist[1];                                     //~0109I~
	PNPWORKT pnpwt=(PNPWORKT)plist[2];                             //~0109I~
	int *pdata=(int*)plist[3];                                     //~0109I~
	int den=*(int*)plist[4];                                       //~0109I~
	int tmsgfreq=*(int*)(plist[5]);                                //~0109I~
	int repeatmax=*(int*)plist[6];                                 //~0109I~
	int seed=*(int*)plist[7];                                      //~0109I~
	int plan=*(int*)plist[8];                                      //~0109I~
	int level=*(int*)plist[9];                                     //~0109I~
	int *pactseed=(int*)plist[10];                                 //~0109I~
	int *prc=(int*)plist[11];                                      //~0109I~
	char *rcmsg=(char*)plist[12];                                  //~0109I~
                                                                   //~0109I~
    try                                                            //~0109I~
    {                                                              //~0109I~
    	GblSubthreadsw=1;                                          //~0110R~
		GblSubthreadStopReq=0;                                     //~0110I~
    	GblUerrexitsw=0;                                           //~0110I~
	    GblNpsubMsg=0;                                             //~0110I~
                                                                   //~0110I~
		*prc=xnpmakequestion(opt,pnpwt,                            //~0109I~
				pdata,den,tmsgfreq,repeatmax,seed,plan,level,pactseed);//~0109I~
		pBoard->Npsuberr1(*prc);                                    //~0109I~
	}                                                              //~0109I~
    catch(CException E){pBoard->Npsuberr2(&E);}                    //~0109I~
    catch(...)    {pBoard->Npsuberr3();}                           //~0109I~
    pview->KillTimer(IDC_MAKE);                                    //~0109I~
	pview->PostMessage(WM_COMMAND,IDC_ENDTH);                      //~0110R~
    return 0;                                                      //~0109I~
}                                                                  //~0109I~
void Board::Npsuberr1(int rc)                                      //~0122M~
{                                                                  //~0122M~
    CString s; 
	char *pc;                                                      //~0122M~
    if (!(pc=GblNpsubMsg))                                         //~0122M~
    	pc="";                                                     //~0122M~
    if (!rc)                                                       //~0122M~
    {                                                              //~0211I~
        s.Format("%s",pc);                                         //~0205R~
        if (Npworkt.level & LEVEL_HARDP2_S)                        //~0211M~
        	sProbLevel="++";                                     //~0211M~
        else                                                       //~0211M~
        if (Npworkt.level & LEVEL_HARDP1_S)                        //~0211M~
        	sProbLevel="+";                                      //~0211M~
        else                                                       //~0211M~
        if (Npworkt.level & LEVEL_HARD_S)                          //~0211M~
        	sProbLevel="";                                       //~0211M~
        else                                                       //~0211M~
        if (Npworkt.level & LEVEL_MEDIUM_S)                        //~0211M~
        	sProbLevel="";                                       //~0211M~
        else                                                       //~0211M~
        if (Npworkt.level & LEVEL_EASY_S)                          //~0211R~
        	sProbLevel="";                                       //~0211R~
        else                                                       //~0211I~
        	sProbLevel="";                                         //~0211I~
	}                                                              //~0211I~
    else                                                           //~0122M~
    {                                                              //~0211I~
        s.Format("s;(rc=%d)%s",rc,pc);                          //~0122M~
        sProbLevel="";                                             //~0211I~
	}                                                              //~0211I~
    SetTempMsg(s);                                                 //~0122M~
    sSuccessMsg=s;                                                //~0129I~
}                                                                  //~0122M~
void Board::Npsuberr2(CException *E)                               //~0122M~
{                                                                  //~0122M~
static char msgbuff[1024];                                         //~0122M~
    if (GblNpsubMsg)                                               //~0122M~
    {                                                              //~0122M~
    	CString s;                                                 //~0122M~
        s.Format("G[1;%s",GblNpsubMsg);                        //~0122M~
        SetTempMsg(s);                                             //~0122M~
    }                                                              //~0122M~
    else                                                           //~0122M~
    {                                                              //~0122M~
        if (E->GetErrorMessage(msgbuff,sizeof(msgbuff)))           //~0122M~
            SetTempMsg(msgbuff);                                   //~0122M~
        else                                                       //~0122M~
            SetTempMsg("CException");                          //~0122M~
    }                                                              //~0122M~
    NpsubRc=253;                                                   //~0122M~
}                                                                  //~0122M~
void Board::Npsuberr3()                                            //~0122M~
{                                                                  //~0122M~
    if (GblUerrexitsw)                                             //~0122M~
    {                                                              //~0122M~
        SetTempMsg(GblNpsubMsg);                                   //~0122M~
    	NpsubRc=254;                                               //~0122M~
    }                                                              //~0122M~
    else                                                           //~0122M~
    {                                                              //~0122M~
        if (GblNpsubMsg)                                           //~0122M~
        {                                                          //~0122M~
            CString s;                                             //~0122M~
            s.Format("G[2;%s",GblNpsubMsg);                    //~0122M~
            SetTempMsg(s);                                         //~0122M~
        }                                                          //~0122M~
        else                                                       //~0122M~
            SetTempMsg("CŗO...");                          //~0122M~
    	NpsubRc=255;                                               //~0122M~
    }                                                              //~0122M~
}                                                                  //~0122M~
