//CID://+v022R~:                                                   //+v022R~
//*************************************************************
//*XNPSUB.H
//*************************************************************
//v022:051102 redundancy chk:max depth parm missing(no depth chk done at xnpsub)//+v022I~
//v021:051102 redundancy chk:display also reduduncy depth count    //~v021I~
//*000103 xnp v0.1:Win(C++) support                                //~v0.1I~
//*v100 first
//*************************************************************
#define ANS_TIMEOUT      15   		//loop max time limit(seconds) //~v0.1R~
#define ANS_MSGFREQ      3  		//no time msg frequency        //~v0.1R~
#define MAKE_TIMEOUT     0xffff		//loop max time limit(seconds) //~v0.1I~
#define MAKE_MSGFREQ     10  		//time msg frequency each 10 seconds//~v0.1I~
                                                                   //~v0.1I~
#define XNP_MINIDATA	  18   //minimum idata count               //~v0.1I~
#define XNP_MAXRLIST	  81                                       //~v0.1I~
//for Popt
#define XNP_TEST 		0x01
#define XNP_PILOT		0x02
#define XNP_PILOTNOMSG	0x04
#define XNP_REDUNDANTCK 0x08
#define XNP_RIGID       0x10
#define XNP_NOPRINTIN   0x20
#define XNP_NOPRINTOUT  0x40
#define XNP_PRINTIDATA  0x80
#define XNP_ANSOFMAKE   0x0100                                     //~v00zI~
#define XNP_SOLOFMAKE   0x0200                                     //~v0.1R~
#define XNP_SORT        0x0400                                     //~v0.1I~
#define XNP_RLEVELMASK  0xf000

//#define XNP_SOLVMASK    (XNP_TEST|XNP_PILOT|XNP_PILOTNOMSG|XNP_REDUNDANTCK|XNP_SORT)//+v022R~
#define XNP_SOLVMASK    (XNP_TEST|XNP_PILOT|XNP_PILOTNOMSG|XNP_REDUNDANTCK|XNP_SORT|XNP_RLEVELMASK)//+v022I~
#define XNP_MAKEMASK    (XNP_TEST|XNP_RIGID|XNP_PILOT|XNP_ANSOFMAKE|XNP_SOLOFMAKE|XNP_SORT)//~v0.1R~

#define ALL_CANDIDATE   0x1ff	//candidate bit mask for all 9,8,...1

//for last level summary msg
#define LEVEL_SUM         0xff00
#define LEVEL_EASY_S      0x0100
#define LEVEL_MEDIUM_S    0x0200
#define LEVEL_HARD_S      0x0400
#define LEVEL_HARDP1_S    0x0800
#define LEVEL_HARDP2_S    0x1000
//for pilot msg(each time on/off)
#define LEVEL_FIX         0xff
#define LEVEL_EASY_F      0x01
#define LEVEL_MEDIUM_F    0x02
#define LEVEL_HARD_F      0x04
#define LEVEL_HARDP1_F    0x08
#define LEVEL_HARDP2_F    0x10

#define LEVEL_INIT       0    	//for dificulty level,initial data //~v00zM~
                                                                   //~v00zI~
#define LEVEL_EASY       (LEVEL_EASY_S|LEVEL_EASY_F)               //~v00zM~
#define LEVEL_MEDIUM     (LEVEL_MEDIUM_S|LEVEL_MEDIUM_F)           //~v00zM~
#define LEVEL_HARD       (LEVEL_HARD_S|LEVEL_HARD_F)               //~v00zM~
#define LEVEL_HARDP1     (LEVEL_HARDP1_S|LEVEL_HARDP1_F)           //~v00zM~
#define LEVEL_HARDP2     (LEVEL_HARDP2_S|LEVEL_HARDP2_F)           //~v00zM~
                                                                   //~v00zI~
typedef struct _M99 {
			int    flag;		//flag for make
#define M99F_LIMIT	0x01		//out of candidate by the reason of SETMAX limit
#define M99F_PATERN 0x02		//pos requested by patern file
            int    fnum;    	//fixed number tbl,0 if not fixed
            int    fseq;    	//fixed seqno for each pos
            int    dlvl;    	//difficulty level
            int    cmsk;    	//candidate bit mask for each pos
            int    ccnt;    	//candidate count for each pos
            int    pair;    	//candidate paired once(to avoid repeat)
            		} M99,*PM99;		//in progree table
typedef struct _NPWORKT {
			int    stat;		//process status
#define STAT_PILOT            0x0100
#define STAT_PILOTMSG         0x0200
#define STAT_MAKE             0x0400
#define STAT_RCHK             0x0800
#define STAT_ANSOFMAKE        0x0010                               //~v00zR~

#define STAT_DATA_CONFLICT    0x1000
#define STAT_MULTISOL         0x2000
#define STAT_TIMEOUT          0x4000                               //~v0.1I~
			int    taelvl;			//try and err depth            //~v00zI~
#define MAX_TAELVL            15                                   //~v00zI~
			char  *method;   		//candidate bit reseted method
            int    seqno;     		//seqno when a number is fixed
            int    idatano;   		//initial datano
            int    level;   		//dificulty level
            M99    m99[9][9];    	//per place
            int    fmsk[3][9];    	//fixed number mask for each row,col,box
            int    fcnt[3][9];    	//fixed count  for each row,col,box
            int    icnt[3][9];    	//initial data cnt for make puzzle
            int    rclistcnt;                                      //~v0.1I~
            int    rclevel;         //max redundancy depth         //~v021I~
            int   *rclist; 			//static area in xnpsub        //~v0.1I~
            		} NPWORKT,*PNPWORKT;		//in progree table
#define NPWORKTSZ (sizeof(NPWORKT))
//*************************************************************
int xnpansinit(int Popt,int *Pdata,PNPWORKT Ppnpwt);
//*************************************************************
void xnpprintnum(int Popt,int Prow,int Pcol,PNPWORKT Ppnpwt,int Plevel,char *Pcase);
//*************************************************************
#ifdef WNP_INC_CPP     //includeed in CPP source                   //~v0.1R~
extern  "C" {                                                      //~v0.1R~
#endif                                                             //~v0.1I~
int xnpgetanswer(int Popt,int *Pdata,PNPWORKT Ppnpwt,int Ptmsgfreq,int Prepeatmax);//~v0.1R~
int xnpsortdata(int *Ppdata,int *Ppdatamask);                      //~v0.1R~
#ifdef WNP_INC_CPP     //includeed in CPP source                   //~v0.1I~
}                                                                  //~v0.1I~
#endif                                                             //~v0.1I~
//*************************************************************
int xnpsolution(PNPWORKT Ppnpwt);
//*************************************************************
int xnpfix(int Prow,int Pcol,int Pnum,PNPWORKT Ppnpwt,int Pmethod,char *Pcase);
//*************************************************************
void xnpprintcan(PNPWORKT Ppnpwt);
//*************************************************************
void xnptrace(PNPWORKT Ppnpwt);
