//CID://+v024R~:                                                   //~v024R~
//******************************************************************************//~v012I~
//v024:051103 (BUG)restore also score when restore pending game    //~v024I~
//v015:051005 (BUG)filename change by SaveAs operation             //~v015I~
//v012:051004 dosenot write answer when in solving                 //~v012I~
//******************************************************************************//~v012I~
// Pattern.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Wnpdef.h"
#include "wnpmfc.h"
#include "Pattern.h"
#include "Board.h"                                                 //~v012I~

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAXLINE 256                                               //~0102I~
IMPLEMENT_SERIAL(CPattern,CObject,0)                               //~0102I~
/////////////////////////////////////////////////////////////////////////////
// CPattern

CPattern::CPattern()
{
	Name="VK";                                                   //~0102R~
	for (int y=0;y<MAP_SIZE;y++)                                   //~0102I~
		for (int x=0;x<MAP_SIZE;x++)                               //~0102I~
        	QuestionData[y][x]=0; 
    memset(PendingData,0,sizeof(PendingData));                     //~v012R~
    Datasw=0;                                                      //~0108R~
    Modifiedsw=0;                                                  //~0108I~
//  SeedSet=0;                                                     //~v012R~
    Seed=0;                                                        //~v012R~
}

CPattern::~CPattern()
{
}

/////////////////////////////////////////////////////////////////////////////
// CPattern bZ[W nh

void CPattern::Serialize(CArchive& ar,void *PpBoard)               //~v012R~
{
#define SEED_PREFIX "ԍ"                                   //~v012I~
#define SCORE_PREFIX "XRA"                                    //~v024I~
    int mode;                                                      //~v012I~
	int x,y;                                                       //~0102R~
    BYTE line[MAXLINE];                                            //~0102I~
    BYTE numstr[MAP_SIZE][MAXLINE];                                //~0102I~
    int  inpnum[MAP_SIZE][MAP_SIZE];                               //~v012I~
    BYTE *pc=&line[0];                                                 //~0102I~
    int  idata,ii,jj,err=0;                                        //~0129R~
    DWORD len;                                                     //~0102I~
    CFile *fp=ar.GetFile();                                        //~0102I~
    int pendsw=0;                                                  //~v012R~
    Board *pBoard;                                                 //~v012I~
    char *pc2;                                                     //~v012I~
    CString name;                                                  //~v015I~
//*****************************************                        //~v012I~
    pBoard=(Board*)PpBoard;                                        //~v012I~
    mode=pBoard->GetMode();                                        //~v012R~
//chk pending data                                                 //~v012I~
//  Name=fp->GetFileName();                                        //~v015R~
    name=fp->GetFileName();                                        //~v015I~
    if (ar.IsStoring()) //on output                                //~0103R~
    {                                                              //~0102I~
    	pBoard->CalcScore();                                       //+v024R~
	    pBoard->GetInpnum((int *)inpnum);                          //~v012I~
        for (y=0;y<MAP_SIZE;y++)                                   //~v012I~
        {                                                          //~v012I~
            for (x=0;x<MAP_SIZE;x++)                               //~v012I~
            {                                                      //~v012I~
                if (!QuestionData[y][x])                           //~v012I~
                    if (inpnum[y][x])                              //~v012I~
                    {                                              //~v012I~
                        pendsw=1;                                  //~v012I~
                        break;                                     //~v012I~
                    }                                              //~v012I~
            }                                                      //~v012I~
        }                                                          //~v012I~
//  	sprintf((char *)line,"# FileName=%s",Name);                //~v015R~
    	sprintf((char *)line,"# FileName=%s",name);                //~v015I~
      if (pendsw==0||                                              //~v012I~
          (mode==MODE_OUTANS && Datasw & DATA_ANS))	//ans avail(not modified)//~v012R~
      {                                                            //~v012I~
    	PutLine(ar,line,2);                                        //~0102R~
//      if (SeedSet)                                               //~v012R~
        if (Seed)                                                  //~v012I~
        {                                                          //~0129I~
    		sprintf((char *)line,"#------ f[^ ------(" SEED_PREFIX "%d)",Seed);//~v012R~
    		PutLine(ar,line,2);                                    //~0129R~
		}                                                          //~0129I~
        else                                                       //~0129I~
    		PutLine(ar,(PBYTE)"#------ f[^ ------",2);      //~0129R~
        for (y=0;y<MAP_SIZE;y++)                                   //~0102I~
        {                                                          //~0102I~
        	sprintf((char *)line,"  %c  %c  %c   %c  %c  %c   %c  %c  %c",//~0102R~
            	QuestionData[y][0] ? QuestionData[y][0]+'0':'_',   //~0102I~
            	QuestionData[y][1] ? QuestionData[y][1]+'0':'_',   //~0102R~
            	QuestionData[y][2] ? QuestionData[y][2]+'0':'_',   //~0102R~
            	QuestionData[y][3] ? QuestionData[y][3]+'0':'_',   //~0102R~
            	QuestionData[y][4] ? QuestionData[y][4]+'0':'_',   //~0102R~
            	QuestionData[y][5] ? QuestionData[y][5]+'0':'_',   //~0102R~
            	QuestionData[y][6] ? QuestionData[y][6]+'0':'_',   //~0102R~
            	QuestionData[y][7] ? QuestionData[y][7]+'0':'_',   //~0102R~
            	QuestionData[y][8] ? QuestionData[y][8]+'0':'_');  //~0102R~
	    	PutLine(ar,(PBYTE)line,1);                             //~0102R~
        }                                                          //~0102I~
//  	if (Datasw & DATA_ANS)	//ans avail(not modified)          //~v012R~
    	if (mode==MODE_OUTANS && Datasw & DATA_ANS)	//ans avail(not modified)//~v012I~
        {                                                          //~0129I~
    		PutLine(ar,(PBYTE)" ",2);                              //~0129I~
    		PutLine(ar,(PBYTE)"#------  ------",2);              //~0129I~
        	for (y=0;y<MAP_SIZE;y++)                               //~0129I~
        	{   
				pc=&line[0];//~0129I~
	        	for (x=0;x<MAP_SIZE;x++)                           //~0129I~
                {                                                  //~0129I~
    	        	if (QuestionData[y][x])                        //~0129I~
                    	pc+=sprintf((char *)pc,"  %d",QuestionData[y][x]);//~0213R~
                    else                                           //~0129I~
                    	if (AnswerData[y][x])                      //~0213R~
                    		pc+=sprintf((char *)pc," *%d",AnswerData[y][x]);//~0213I~
                        else                                       //~0213I~
                    		pc+=sprintf((char *)pc,"  _");         //~0213I~
                                                                   //~0129I~
					if (!((x+1)%3))                                //~0129I~
                    	pc+=sprintf((char *)pc," ");                         //~0129I~
				}                                                  //~0129I~
	    		PutLine(ar,(PBYTE)line,1);                         //~0129I~
        	}                                                      //~0129I~
        }                                                          //~0129I~
      }                                                            //~v012I~
      else                                                         //~v012R~
      {                                                            //~v012R~
    		PutLine(ar,(PBYTE)" ",2);                              //~v012I~
//      	if (Seed)                                              //~v024R~
//      	{                                                      //~v024R~
//  			sprintf((char *)line,"#------ ro ------(" SEED_PREFIX "%d)",Seed);//~v024R~
//  			PutLine(ar,line,2);                                //~v024R~
//  		}                                                      //~v024R~
//      	else                                                   //~v024R~
//  			PutLine(ar,   (PBYTE)"#------ ro ------",2); //~v024R~
  			sprintf((char *)line,"#------ ro ------(" SEED_PREFIX "%d;" SCORE_PREFIX "%d/%d)",Seed,pBoard->Score,pBoard->ScoreMax);//~v024R~
   			PutLine(ar,line,2);                                    //~v024I~
        	for (y=0;y<MAP_SIZE;y++)                               //~v012I~
        	{                                                      //~v012I~
				pc=&line[0];                                       //~v012I~
	        	for (x=0;x<MAP_SIZE;x++)                           //~v012I~
                {                                                  //~v012I~
    	        	if (QuestionData[y][x])                        //~v012I~
                    	pc+=sprintf((char *)pc,"  %d",QuestionData[y][x]);//~v012I~
                    else                                           //~v012I~
                    	if (inpnum[y][x])                          //~v012I~
                    		pc+=sprintf((char *)pc," ?%d",inpnum[y][x]);//~v012R~
                        else                                       //~v012I~
                    		pc+=sprintf((char *)pc,"  _");         //~v012I~
                                                                   //~v012I~
					if (!((x+1)%3))                                //~v012I~
                    	pc+=sprintf((char *)pc," ");               //~v012I~
				}                                                  //~v012I~
	    		PutLine(ar,(PBYTE)line,1);                         //~v012I~
        	}                                                      //~v012I~
      }                                                            //~v012R~
	    Modifiedsw=0;                                              //~0129I~
    }                                                              //~0102I~
	else        //on input                                         //~0103R~
    {                                                              //~0102I~
	    memset(PendingData,0,sizeof(PendingData));                 //~v012R~
	    Datasw=DATA_FILE;                                          //~0129R~
        ClearAnsData();	                                           //~0213I~
	    Modifiedsw=0;                                              //~0108I~
	    len=fp->GetLength();                                       //~0102I~
        Score=ScoreMax=0;                                          //~v024I~
        for (ii=0;;)                                               //~0102I~
        {                                                          //~0102I~
    		if (GetLine(ar,(PBYTE)line,&len))                      //~0102R~
            {                                                      //~0102I~
            	err=1;                                             //~0102I~
            	break;                                             //~0102I~
			}                                                      //~0102I~
            if (line[0]=='#')                                      //~0102I~
            {                                                      //~v012I~
                if (pc2=strstr((const char *)line,SEED_PREFIX),pc2)//~v012R~
                	Seed=atoi(pc2+sizeof(SEED_PREFIX)-1);          //~v012I~
                if (pc2=strstr((const char *)line,SCORE_PREFIX),pc2)//~v024I~
                {                                                  //~v024I~
                	pc2+=sizeof(SCORE_PREFIX)-1;                   //~v024I~
                	Score=atoi(pc2);                               //~v024I~
                	pc2=strchr(pc2,'/');                           //~v024R~
                    if (pc2)                                       //~v024I~
                    	ScoreMax=atoi(pc2+1);                      //~v024I~
                }                                                  //~v024I~
            	continue;                                          //~0102I~
            }                                                      //~v012I~
            if (strlen((const char*)line)==PEG_MAX) //81 digt and lf            //~0102I~
            {                                                      //~0102I~
                for (int jj=0;jj<PEG_MAX;jj++,pc++)           //~0102I~
                {                                                  //~0102I~
                    if (*pc>='0' && *pc<='9')                      //~0102I~
                        idata=*pc-'0';                             //~0102I~
                    else                                           //~0102I~
                        idata=0;                                   //~0102I~
            		QuestionData[jj/MAP_SIZE][jj%MAP_SIZE]=idata;        //~0102I~
                }                                                  //~0102I~
                ii=9;                                              //~0102I~
                break;      //return                               //~0102I~
            }                                                      //~0102I~
            int fldno=sscanf((char *)line,"%s %s %s %s %s %s %s %s %s",        //~0102I~
                                numstr[0],numstr[1],numstr[2],     //~0102I~
                                numstr[3],numstr[4],numstr[5],     //~0102I~
                                numstr[6],numstr[7],numstr[8]);    //~0102I~
            if (fldno<=0)   //no data or all space                 //~0102I~
                continue;                                          //~0102I~
            if (fldno!=MAP_SIZE)                                   //~0102I~
            {                                                      //~0102I~
            	err=1;                                             //~0102I~
                continue;                                          //~0102I~
            }                                                      //~0102I~
            for (jj=0,pc=&numstr[0][0];jj<MAP_SIZE;jj++,pc+=MAXLINE)//~0102I~
            {                                                      //~0123I~
              if (*pc=='?')	//pending data                         //~v012I~
            	PendingData[ii][jj]=atoi((const char*)(pc+1));     //~v012R~
              else                                                 //~v012I~
            	QuestionData[ii][jj]=atoi((const char*)pc);                     //~0102I~
            }                                                      //~0123I~
            if (++ii==9)                                           //~0102I~
            	break;                                             //~0102I~
		}                                                          //~0102I~
        if (err)                                                   //~0102I~
        {                                                          //~0108I~
		    AfxMessageBox("f[^Ɍ肪܂",MB_OK);  //~0102I~
            Datasw|=DATA_ERR; //err data                           //~0129R~
        }                                                          //~0108I~
    	Name=name;                                                 //~v015R~
    }                                                              //~0102I~
}

void CPattern::operator =(const CPattern &src)                       //~0102R~
{
	Name=src.Name;                                                 //~0102R~
	int x,y;                                                       //~0102I~
    for (y=0;y<MAP_SIZE;y++)                                       //~0102I~
        for (x=0;x<MAP_SIZE;x++)                                   //~0102I~
            QuestionData[y][x]=src.QuestionData[y][x];             //~0102I~
}
void CPattern::PutLine(CArchive &ar,BYTE *pByte,int Plfno)         //~0102R~
{                                                                  //~0102I~
    int cnt=strlen((const char*)pByte);                                         //~0102I~
    for (int ii=0;ii<cnt;ii++)                                     //~0102I~
    	ar<<*pByte++;                                              //~0102R~
	for (ii=0;ii<Plfno;ii++)                                       //~0102I~
    {	                                                           //~0102I~
    	ar<<(BYTE)0x0d;                                            //~0102R~
    	ar<<(BYTE)0x0a;                                            //~0102R~
    }                                                              //~0102I~
}                                                                  //~0102I~
int  CPattern::GetLine(CArchive &ar,BYTE *pByte,DWORD *Pplen)      //~0102R~
{                                                                  //~0102I~
	BYTE ch;                                                       //~0102I~
    int err=0,ii,jj;                                               //~0102R~
    for (ii=0,jj=0;ii<MAXLINE-1;ii++)                              //~0102R~
    {                                                              //~0102R~
        if (!*Pplen)                                               //~0102I~
            return 4;       //eof                                  //~0102I~
        ar>>ch;                                                    //~0102R~
        *Pplen=*Pplen-1;                                           //~0102I~
        if (ch!=0x0d && ch!=0x0a)                                  //~0102R~
        {                                                          //~0102I~
        	*(pByte+ii)=ch;                                        //~0102R~
            jj=ii+1;                                               //~0102R~
		}                                                          //~0102I~
        if (ch==0x0a)                                              //~0102R~
            break;                                                 //~0102R~
    }                                                              //~0102R~
    *(pByte+jj)=0;                                                 //~0102R~
    int offs=strspn((const char*)pByte," ");                                    //~0102I~
    if (offs)                                                      //~0102I~
	    strcpy((char*)pByte,(char*)pByte+offs);                     //~0102I~
	return 0;                                                      //~0102I~
}                                                                  //~0102I~
BOOL CPattern::ChkData(void)                                       //~0102I~
{                                                                  //~0102I~
    for (int y=0;y<MAP_SIZE;y++)                                   //~0102I~
        for (int x=0;x<MAP_SIZE;x++)                               //~0102I~
        	if (QuestionData[y][x])            //~0102I~
                return TRUE;                                       //~0102I~
	return FALSE;                                                  //~0102I~
}                                                                  //~0102I~
//*********************************************************************//~0103I~
void CPattern::SetNewData(int bx,int by,int num,int Psortsw)       //~0130R~
{                                                                  //~0108I~
    if ((int)QuestionData[bx][by]!=num)                                 //~0108R~
    {                                                              //~0108I~
    	QuestionData[bx][by]=num;                                  //~0108I~
    	Modifiedsw=1;                                              //~0108R~
        if (!Psortsw)                                              //~0130I~
        Datasw&=~DATA_ANS;    //ans not avail                      //~0129I~
    }                                                              //~0108I~
}                                                                  //~0108I~
//*********************************************************************//~0129I~
void CPattern::SetAnsData(int bx,int by,int num)                   //~0129I~
{                                                                  //~0129I~
	Datasw|=DATA_ANS;		//for later modification;              //~0129I~
    AnswerData[bx][by]=num;                                        //~0129I~
}                                                                  //~0129I~
//*********************************************************************//~0312I~
int  CPattern::GetAnsData(int bx,int by)                           //~0312I~
{                                                                  //~0312I~
    return AnswerData[bx][by];                                     //~0312I~
}                                                                  //~0312I~
void CPattern::ClearAnsData()                                      //~0213I~
{                                                                  //~0213I~
	Datasw&=~DATA_ANS;		//for later modification;              //~0213I~
    for (int y=0;y<MAP_SIZE;y++)                                   //~0213I~
        for (int x=0;x<MAP_SIZE;x++)                               //~0213I~
        	AnswerData[y][x]=0;                                    //~0213I~
}                                                                  //~0213I~
int CPattern::GetModified()                                        //~0108R~
{                                                                  //~0108I~
	int modsw=Modifiedsw;                                              //~0108I~
	Modifiedsw=0;                                                  //~0108I~
    return modsw;                                                  //~0108I~
}                                                                  //~0108I~
