//CID://+v018R~:                                                   //~v018R~
//******************************************************************************//~v011I~
//v018:051012 allow only once pswd err,restart allow but sleep 1 min after err pswd//~v018I~
//v016:051009 (BUG)reg key is volatile                             //~v016I~
//v015:051009 do not write pswd itself to registry                 //~v015I~
//v011:051003 limit make without pswd max 30;                      //~v011I~
//v007:051002 abend when pswd canceled                             //~v007I~
//v002:000312 enter ans mode after make automaticaly               //~v002I~
//*** VC++ & MFC ***************************************************************//~9C12I~
//*       ** ButtonDlg.cpp **                                      //~9C12I~
//******************************************************************************//~9C12I~
//*/                                                               //~9C12I~
#include <sys/timeb.h>                                             //~v015I~
#include    "StdAfx.h"                                             //~9C25I~
#include	"resource.h"                                           //~v002I~
#include	"wnpdef.h"                                             //~v002I~
#include	"Pswd.h"                                               //~v002M~
                                                                   //~9C12I~
//******************************************************************************//~v002I~
#define NP_KEYNAME   "WNPMFC"                                      //~v002I~
#define NP_KEYVALUE  "pswd"                                        //~v002I~
#define NP_KEYNAMEMK "WNPMFCMK"                                    //~v011I~
#define MAKE_LIMIT   30                                            //~v011I~
#define COUNTSZ      32                                            //~v011I~
//******************************************************************************//~v002I~
/*                                                                 //~9C12I~
*****************************************************************  //~9C12I~
    bZ[W}bv                                               //~9C12I~
******************************************************************///~9C12I~
BEGIN_MESSAGE_MAP( PswdDlg, CDialog )                            //~9C12I~
    ON_WM_PAINT()                                                  //~9C12I~
    ON_COMMAND(IDOK,OnOk)                                          //~v002I~
    ON_COMMAND(IDCANCEL,OnCancel)                                  //~v002I~
END_MESSAGE_MAP()                                                  //~9C12I~
                                                                   //~9C12I~
//=======================================================================//~v002I~
Pswd::Pswd(CWnd* p_parent)                                         //~v002I~
{                                                                  //~v002I~
	pParent=p_parent;                                              //~v002I~
    Dialogsw=0;                                                    //~v002I~
}                                                                  //~v002I~
//=======================================================================//~v002I~
//=rc 0:pswd ok,-1:waiting pswd input,1:dialog issed now,4:pswd err//~v002I~
//=======================================================================//~v002I~
int  Pswd::GetPswd()                                               //~v002R~
{                                                                  //~v002M~
	UCHAR pswd[PSWDSZ];                                            //~v002I~
    int rc;                                                        //~v002I~
	DWORD pswdsz;                                                  //~v002I~
//  DWORD makecountsz;                                             //~v018R~
    DWORD disp=0;                                                  //~v002I~
//  char msg[128];                                                 //~v018R~
//  char makecount[COUNTSZ];                                       //~v018R~
//  int mkc;                                                       //~v018R~
    struct timeb tmb;                                              //~v015I~
    int ctime;                                                     //~v015I~
//*********************                                            //~v002I~
    pswdsz=sizeof(pswd);                                         //~v002I~
	rc=::ureg_keygetvalue((UCHAR*)NP_KEYNAME,pswd,&pswdsz);        //~v002I~
//  if (!rc && !ChkPswd((char*)pswd))                              //~v015R~
    if (!rc && !ChkRegPswd((char*)pswd))                           //~v015I~
    	return 0;		//pswd ok                                  //~v002I~
    switch(Dialogsw)                                               //~v002I~
    {                                                              //~v002I~
    case 0:                                                        //~v002I~
    	pPswdDlg = new PswdDlg(pParent,this);                      //~v002R~
        return 1;		//issued dialog                            //~v002I~
    case 1:                                                        //~v002I~
        return -1;		//waiting dialog input                     //~v002R~
    case 2:				//dialog closed                            //~v002I~
	    delete (PswdDlg*)pPswdDlg;                                 //~v002I~
	    pPswdDlg=0;                                                 //~v002I~
    	if (!ChkPswd((char*)Pswdinput))                            //~v002R~
        {                                                          //~v002I~
//  		rc=::ureg_keysetvalue((UCHAR*)NP_KEYNAME,(UCHAR*)Pswdinput,&disp);//~v015R~
        	ftime(&tmb);                                           //~v015I~
            ctime=tmb.time;                                        //~v015I~
            ctime=(ctime<<8)|(ctime>>24);                          //~v015I~
            ctime&=0xffff0fff;  //set succes bit  0x3000           //~v015I~
            ctime|=0x3000;                                         //~v015I~
            sprintf(Pswdinput,"%08x",ctime);                       //~v015I~
    		rc=::ureg_keysetvalue((UCHAR*)NP_KEYNAME,(UCHAR*)Pswdinput,&disp);//~v015I~
            pParent->MessageBox("pX[hnj",NULL,MB_OK);      //~v015I~
        	return 0;	//pswd ok                                  //~v002I~
		}                                                          //~v002I~
//        rc=::ureg_keygetvalue((UCHAR*)NP_KEYNAMEMK,(UCHAR*)makecount,&makecountsz);//~v018R~
//        if (rc==0)                                               //~v018R~
//        {                                                        //~v018R~
//            mkc=atoi((const char *)makecount);                   //~v018R~
//            mkc=((UINT)mkc>>16)|((UINT)mkc<<16);    //swap high and low//~v018R~
//            if (((mkc>>24) & 0x40)!=0x40)                        //~v018R~
//            {                                                    //~v018R~
//                rc=4;                                            //~v018R~
//                mkc=mkc&0x3f;                                    //~v018R~
//            }                                                    //~v018R~
//            else                                                 //~v018R~
//                mkc=mkc&0x3f;                                    //~v018R~
//        }                                                        //~v018R~
//        if (rc || mkc<MAKE_LIMIT)                                //~v018R~
//        {                                                        //~v018R~
//            mkc++;                                               //~v018R~
//            if ((mkc%10==0)||(mkc+1==MAKE_LIMIT))                //~v018R~
//            {                                                    //~v018R~
//                sprintf(msg," %d  ł܂",MAKE_LIMIT-mkc);//~v018R~
//                pParent->MessageBox(msg,NULL,MB_OK);             //~v018R~
//            }                                                    //~v018R~
//            ftime(&tmb);                                         //~v018R~
//            ctime=tmb.time;                                      //~v018R~
//            mkc=(ctime & 0xffffffc0)+mkc;                        //~v018R~
//            mkc=((UINT)mkc>>16)|((UINT)mkc<<16);    //swap high and low//~v018R~
//            sprintf(makecount,"%d",mkc);                         //~v018R~
//            rc=::ureg_keysetvalue((UCHAR*)NP_KEYNAMEMK,(UCHAR*)makecount,&disp);//~v018R~
//            return 0;                                            //~v018R~
//        }                                                        //~v018R~
//        else                                                     //~v018R~
//            pParent->MessageBox("pX[h擾Ă",NULL,MB_OK);//~v018R~
        pParent->MessageBox("pX[hG[",NULL,MB_OK);        //~v018I~
        Sleep(60000);  	//1min                                     //+v018R~
    }                                                              //~v002I~
    return 4;			//pswd err                                 //~v002I~
}                                                                  //~v002M~
//=======================================================================//~v002I~
int  Pswd::SetPswd(char *Ppswd)                                    //~v002I~
{                                                                  //~v002I~
//************************                                         //~v002I~
	strncpy(Pswdinput,Ppswd,PSWDSZ-1);                             //~v002R~
//  *(Ppswd+PSWDSZ-1)=0;    //it may on text segment               //~v007R~
    Dialogsw=2;                                                    //~v002I~
    return *Ppswd!=0;                                              //~v002R~
}                                                                  //~v002I~
//=======================================================================//~v002I~
int  Pswd::ChkRegPswd(char *Ppswd)                                 //~v015I~
{                                                                  //~v015I~
    int  pswdwk=0;                                                 //~v015R~
//************************                                         //~v015I~
    sscanf(Ppswd,"%x",&pswdwk);                                    //~v015R~
    if ((pswdwk&0x3000)==0x3000)                                   //~v015R~
    	return 0;                                                  //~v015I~
    return 4;                                                      //~v015I~
}                                                                  //~v015I~
int  Pswd::ChkPswd(char *Ppswd)                                    //~v002I~
{                                                                  //~v002I~
	int ii,jj;                                                     //~v002I~
    char *pc;                                                      //~v002I~
    char pswdwk[PSWDSZ];                                           //~v002I~
//************************                                         //~v002I~
	if (strlen(Ppswd)<6)                                          //~v002I~
    	return 4;                                                  //~v002I~
    sscanf(Ppswd,"%x",pswdwk);                                     //~v002I~
    *(pswdwk+4)=*(pswdwk+2);	//reverse seq                        //~v002I~
    *(pswdwk+5)=*(pswdwk+1);	//reverse seq                        //~v002I~
    *(pswdwk+6)=*(pswdwk+0);	//reverse seq                        //~v002I~
    if (!memcmp(pswdwk+3,MY_SIGN,4))	//special ok               //~v002R~
    	return 0;                                                  //~v002I~
	memcpy(pswdwk,Ppswd,6);                                        //~v002I~
    if (*pswdwk<='9')   //1st should not be numeric                //~v002I~
    	return 4;                                                  //~v002I~
    if (*(pswdwk+5)<='9')   //1st should not be numeric            //~v002I~
    	return 4;                                                  //~v002I~
    for (ii=0,jj=0,pc=pswdwk;ii<6;ii++,pc++)                       //~v002I~
    	jj+=*pc;                                                   //~v002I~
    return jj%19;                                                  //~v002R~
}                                                                  //~v002I~
//=======================================================================//~v002R~
//=======================================================================//~v002I~
//=======================================================================//~v002I~
PswdDlg::PswdDlg(CWnd* p_parent,Pswd *p_pswd)                      //~v002R~
{                                                                  //~9C12I~
    pParent = p_parent;                                            //~9C12I~
    pPswd   = p_pswd;                                              //~v002I~
    CDialog::Create(IDD_PSWD,pParent );                            //~v002I~
    ShowWindow(SW_SHOW);                                 //~v002I~
    pPswd->Dialogsw=1;                                             //~v002I~
}                                                                  //~9C12I~
//=======================================================================//~v002I~
PswdDlg::~PswdDlg()                                                //~v002I~
{                                                                  //~v002I~
    pPswd->Dialogsw=0;                                             //~v002I~
}                                                                  //~v002I~
//=======================================================================//~v002I~
void PswdDlg::OnOk()                                               //~v002I~
{                                                                  //~v002I~
    char pswd[PSWDSZ];                                             //~v002R~
//************************                                         //~v002I~
    ((CEdit*)GetDlgItem(IDC_PSWD))->GetWindowText(pswd,PSWDSZ-1);  //~v002R~
    pPswd->SetPswd(pswd);                                          //~v002I~
	pParent->PostMessage(WM_COMMAND,IDC_PSWDENTER);                //~v002R~
    DestroyWindow();                                               //~v018R~
}                                                                  //~v002I~
//=======================================================================//~v002I~
void PswdDlg::OnCancel()                                           //~v002I~
{                                                                  //~v002I~
//************************                                         //~v002I~
    pPswd->SetPswd("");                                            //~v002I~
	pParent->PostMessage(WM_COMMAND,IDC_PSWDENTER);                //~v002R~
    DestroyWindow();                                               //~v002R~
}                                                                  //~v002I~
//=======================================================================//~v002I~
//*****************************************************************//~v002I~
//*****************************************************************//~v002I~
//*****************************************************************//~v002I~
int ureg_keysetvalue(UCHAR *Pkeyname,UCHAR *Pkeyvalue,ULONG *Pdisp)//~v002I~
{                                                                  //~v002I~
    HKEY hkey=0;                                                   //~v002I~
    LONG rc;                                                       //~v002I~
//**************************                                       //~v002I~
    rc=RegCreateKeyEx(HKEY_CLASSES_ROOT,//parent key               //~v002I~
                           (const char *)Pkeyname,      //keyname  //~v002I~
                           0,                //rsv                 //~v002I~
                           "",               //key class           //~v002I~
//                         REG_OPTION_NON_VOLATILE,      //opt     //~v002I~
//                         REG_OPTION_VOLATILE,          //opt     //~v016R~
                           REG_OPTION_NON_VOLATILE,      //opt     //~v016I~
                           KEY_ALL_ACCESS|KEY_EXECUTE|KEY_SET_VALUE,//access option//~v002I~
                           NULL,			//security             //~v002I~
                           &hkey,			//output handle        //~v002I~
                           Pdisp);			//created or opened    //~v002I~
	printf("CreateKey:rc=%d,hkey=%08x,disp=%08x\n",rc,hkey,*Pdisp);//~v002I~
    if (rc!=ERROR_SUCCESS)                                         //~v002I~
    	return rc;                                                 //~v002I~
    rc=RegSetValueEx(hkey,      //key                              //~v002I~
                       "",           //name                        //~v002I~
                       0,                //rsv                     //~v002I~
                       REG_SZ,           //data type               //~v002I~
                       (const UCHAR*)Pkeyvalue,           //value  //~v002I~
                       strlen((const char*)Pkeyvalue));            //~v002I~
    printf("SetValue:rc=%d\n",rc);                                 //~v002I~
    rc=RegCloseKey(hkey);       //key                              //~v002I~
    printf("CloseKey:rc=%d\n",rc);                                 //~v002I~
    return 0;                                                      //~v002I~
}                                                                  //~v002I~
int ureg_keygetvalue(UCHAR *Pkeyname,UCHAR *Pkeyvalue,ULONG *Pvaluelen)//~v002I~
{                                                                  //~v002I~
    HKEY hkey=0;                                                   //~v002I~
    LONG rc,rcrc;                                                  //~v002I~
    ULONG dwtype;                                                  //~v002I~
//**************************                                       //~v002I~
    rc=RegOpenKeyEx(HKEY_CLASSES_ROOT,//parent key                 //~v002I~
                           (const char *)Pkeyname,      //keyname  //~v002I~
                           0,                //rsv                 //~v002I~
                           KEY_ALL_ACCESS|KEY_EXECUTE|KEY_SET_VALUE,//access option//~v002I~
                           &hkey);			//output handle        //~v002I~
	printf("OpenKey:rc=%d,hkey=%08x\n",rc,hkey);                   //~v002I~
    if (rc!=ERROR_SUCCESS)                                         //~v002I~
    	return rc;                                                 //~v002I~
    rcrc=RegQueryValueEx(hkey,        //key                        //~v002I~
                       "",           //name                        //~v002I~
                       0,                //rsv                     //~v002I~
                       &dwtype,           //data type              //~v002I~
                       Pkeyvalue,           //value                //~v002I~
                       Pvaluelen);                                 //~v002I~
    printf("QueryValue:rc=%d,value=%s,type=%08x,len=%d\n",rc,Pkeyvalue,dwtype,*Pvaluelen);//~v002I~
    rc=RegCloseKey(hkey);       //key                              //~v002I~
    printf("CloseKey:rc=%d\n",rc);                                 //~v002I~
    return rcrc;                                                   //~v002I~
}                                                                  //~v002I~
int ureg_keydeletevalue(UCHAR *Pkeyname)                           //~v002I~
{                                                                  //~v002I~
    HKEY hkey=0;                                                   //~v002I~
    LONG rc,rcrc;                                                  //~v002I~
//**************************                                       //~v002I~
    rc=RegOpenKeyEx(HKEY_CLASSES_ROOT,//parent key                 //~v002I~
                           (const char*)Pkeyname,      //keyname   //~v002I~
                           0,                //rsv                 //~v002I~
                           KEY_ALL_ACCESS|KEY_EXECUTE|KEY_SET_VALUE,//access option//~v002I~
                           &hkey);			//output handle        //~v002I~
	printf("OpenKey:rc=%d,hkey=%08x\n",rc,hkey);                   //~v002I~
    if (rc!=ERROR_SUCCESS)                                         //~v002I~
    	return rc;                                                 //~v002I~
    rc=RegDeleteValue(hkey,        //key                           //~v002I~
                      NULL);                                       //~v002I~
    printf("DeleteValue:rc=%d\n",rc);                              //~v002I~
    rcrc=RegCloseKey(hkey);       //key                            //~v002I~
    printf("CloseKey:rc=%d\n",rc);                                 //~v002I~
    return rcrc;                                                   //~v002I~
}                                                                  //~v002I~
//*****************************************************************//~v002I~
