//CID://+v012R~:                                                   //~v012I~
//******************************************************************************//~v012I~
//v012:051004 dosenot write answer when in solving                 //~v012I~
//

#include "stdafx.h"
#include "wnpdef.h"                                                //~9C25R~
#include "wnpmfc.h"                                                //~9C25I~
#include "Pattern.h"
#include "wnpmfcDoc.h"
#include "Board.h"                                                 //~v012I~
#include "Buttondlg.h"                                             //~v012I~
#include "wnpmfcView.h"                                            //~v012I~

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

///*                                                               //~0102R~
//===================================================================//~0102R~
//  p^[̒`                                                 //~0102R~
//===================================================================*///~0102R~
//SOL_PAT Pattern={0,1,0,0,0,0,3,0,0                               //~0102R~
//                ,0,2,0,0,3,0,0,0,0                               //~0102R~
//                ,0,0,3,0,0,4,0,0,3                               //~0102R~
//                ,0,0,0,4,0,0,9,0,4                               //~0102R~
//                ,0,5,0,0,7,0,0,2,0                               //~0102R~
//                ,0,0,6,0,0,0,0,0,0                               //~0102R~
//                ,0,7,0,0,6,0,0,1,0                               //~0102R~
//                ,0,0,8,5,0,0,2,0,0                               //~0102R~
//                ,0,0,0,0,0,0,0,0,5};                             //~0102R~
/////////////////////////////////////////////////////////////////////////////
// CWnpmfcDoc

IMPLEMENT_DYNCREATE(CWnpmfcDoc, CDocument)

BEGIN_MESSAGE_MAP(CWnpmfcDoc, CDocument)
	//{{AFX_MSG_MAP(CWnpmfcDoc)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWnpmfcDoc NX̍\z/

CWnpmfcDoc::CWnpmfcDoc()
{
	// TODO: ̈ʒuɂP񂾂\zp̃R[hǉĂB
	pPattern=NULL;                                                 //~0102R~
}

CWnpmfcDoc::~CWnpmfcDoc()
{
    delete pPattern;                                               //~0102I~
}

BOOL CWnpmfcDoc::OnNewDocument()
{
	delete pPattern;
	pPattern= new CPattern;
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWnpmfcDoc VAC[[V

void CWnpmfcDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
	}
    pPattern->Serialize(ar,&(((CWnpmfcView*)pView)->aBoard));      //~v012R~
//  UpdateAllViews(NULL);     CreateBoard may be called            //~0129I~
    POSITION pos=GetFirstViewPosition();                           //~0129R~
    if (pos)                                                       //~0129I~
        GetNextView(pos)->Invalidate( FALSE );  //redraw           //~0129I~
}

/////////////////////////////////////////////////////////////////////////////
// CWnpmfcDoc NX̐ff

#ifdef _DEBUG
void CWnpmfcDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CWnpmfcDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWnpmfcDoc R}h


BOOL CWnpmfcDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	delete pPattern;
	pPattern=new CPattern;
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
//  AfxGetApp()->AddToRecentFileList(lpszPathName);                //~v012R~
//  SetPathName(lpszPathName);                                     //+v012R~
	
	return TRUE;
}

void CWnpmfcDoc::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
    pCmdUI->Enable(pPattern->ChkData());                           //~0102I~
	
}

void CWnpmfcDoc::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
    pCmdUI->Enable(pPattern->ChkData());                           //~0102I~
	
}
